<?php

if ( isset( $_GET[ 'dab_concurrency' ] ) ) {
  $concurrency = $_GET[ 'dab_concurrency' ];
  update_option( 'dab_concurrency', $concurrency );
}

define( 'DAB_CONCURRENCY', get_option( 'dab_concurrency', 20 ) );

dpt_admin_menu_width( 175 );

// add pages to menu
add_menu_page( 'Digi Article Blaster', // title of page
               'Digi Article Blaster', // label in menu
               'manage_options', // permissions required
               DAB_OPTIONS_KEY, // slug
               'dab_options_page' ); // function to render page

$settings_page = add_submenu_page( DAB_OPTIONS_KEY, // parent menu slug
                  'Digi Article Blaster Settings', // title of page
                  'Settings', // label in menu
                  'manage_options', // permissions required
                  DAB_OPTIONS_KEY, // slug
                  'dab_options_page' ); // function to render page

// Add the 'Blast' button to post and pages
add_meta_box( 'digiarticleblaster', 'Digi Article Blaster', 'dab_page_box', 'post', 'side', 'high' );
add_meta_box( 'digiarticleblaster', 'Digi Article Blaster', 'dab_page_box', 'page', 'side', 'high' );

// add settings link to plugin listing
add_filter( 'plugin_action_links', 'dab_add_action_link', 10, 2 );

// Check and warn if cURL is not available
// display warning if a captcha service hasn't been provided or no cURL
add_action( 'admin_footer', 'dab_inactive_warning' );

// If they click the blast button then redirect them somewhere else :)
add_filter( 'redirect_post_location', 'dab_check_for_blast_post', 99, 2 );

// Filters for the article content and author bio. Based on the filters for
// the_content and the_title,
add_filter( 'dab_article_text', array( 'DAB_Spinner', 'spin' ) );
// add_filter( 'dab_article_text', 'wptexturize'                  );
add_filter( 'dab_article_text', 'convert_smilies'              );
add_filter( 'dab_article_text', 'convert_chars'                );
add_filter( 'dab_article_text', 'wpautop'                      );
add_filter( 'dab_article_text', 'shortcode_unautop'            );
add_filter( 'dab_article_text', 'dab_filter_line_endings'      );

add_filter( 'dab_article_bio', array( 'DAB_Spinner', 'spin' ) );
// add_filter( 'dab_article_bio', 'wptexturize'                  );
add_filter( 'dab_article_bio', 'convert_smilies'              );
add_filter( 'dab_article_bio', 'convert_chars'                );
add_filter( 'dab_article_bio', 'wpautop'                      );
add_filter( 'dab_article_bio', 'shortcode_unautop'            );
add_filter( 'dab_article_bio', 'dab_filter_line_endings'      );

add_filter( 'dab_article_title', array( 'DAB_Spinner', 'spin' ) );
// add_filter( 'dab_article_title', 'wptexturize'                  );
add_filter( 'dab_article_title', 'convert_chars'                );
add_filter( 'dab_article_title', 'trim'                         );


register_setting( DAB_OPTIONS_KEY, DAB_OPTIONS_KEY );


// Add a custom page (without a menu) to display the post blast page
function _register_custom_admin_page( $name, $cb ) {
  global $_registered_pages;

  $hookname = get_plugin_page_hookname( $name, '' );
  add_action( $hookname, $cb );
  $_registered_pages[$hookname] = true;
}
_register_custom_admin_page('dab_blast', 'dab_blast_page');

// Editor/MCE JS
add_action('admin_print_scripts-admin_page_dab_blast', 'dab_admin_blast_scripts');
// Progress bar JS and CSS
add_action('admin_print_scripts-' . $settings_page, 'dab_progressbar_scripts');
add_action('admin_print_styles-' . $settings_page, 'dab_progressbar_styles');
add_action('admin_print_scripts-admin_page_dab_blast', 'dab_progressbar_scripts');
add_action('admin_print_styles-admin_page_dab_blast', 'dab_progressbar_styles');

// Admin.css for check styles
add_action('admin_print_styles-' . $settings_page, 'dab_admin_blast_styles');


// Remove TinyMCE plugins that don't work on the blast page.
add_filter( 'mce_external_plugins', 'dab_remove_broken_tinymce_plugins', '99');
add_filter( 'mce_buttons_3', 'dab_remove_broken_tinymce_buttons', '99');

# These were introduced in wordpress 3.1
if( !function_exists( 'wp_dequeue_script' ) ) {
  function wp_dequeue_script( $handle ) {
    global $wp_scripts;
    if ( !is_a($wp_scripts, 'WP_Scripts') )
      $wp_scripts = new WP_Scripts();
    $wp_scripts->dequeue( $handle );
  }
}
if( !function_exists("wp_dequeue_style" ) ) {
  function wp_dequeue_style( $handle ) {
          global $wp_styles;
          if ( !is_a($wp_styles, 'WP_Styles') )
                  $wp_styles = new WP_Styles();

          $wp_styles->dequeue( $handle );
  }
}

function dab_progressbar_scripts() {
  wp_enqueue_script('jquery-ui-core');
  wp_enqueue_script('jquery-ui-widget');
  wp_enqueue_script('jquery-ui-progressbar');

  // The PG Countdown Offer plugin includes *another* version of jquery and it
  // somehow breaks things. Remove it.
  wp_dequeue_script('coff-jquery-1.4.4.js');

  // Thesis: Result of expression 'jQuery('.sortable').sortable' [undefined] is not a function.
  wp_dequeue_script('thesis-admin-js');

  // Optin comments has syntax error in jQuery document ready
  remove_action('admin_head', 'optin_addDashboardAlert');

  // WpTuneUp loads jquery 1.5.1 (badly)
  remove_action('admin_head', 'load_wptuneup_assets');

  // Google Custom Search
  wp_dequeue_script( 'gsc_dialog' );
  wp_dequeue_script( 'gsc_jsapi' );

  // WPtap-Themes/Plugin
  remove_action('admin_head', 'wptap_admin_include_js');

  global $dab_original_wp_jquery, $wp_scripts;
  $wp_scripts->registered['jquery'] = $dab_original_wp_jquery;

  // convertazon
  if ( function_exists( 'convertazon_plugin_menu' ) ) {
    wp_dequeue_script('uijquery');
    wp_dequeue_script('jqueryProgressbar');
    wp_dequeue_script('popupscript');
    // Yes, they called it 'script'. Giant dorks
    wp_dequeue_script('script');

    wp_dequeue_style('ProgressbarStyle');
    wp_dequeue_style('popupdoc');
    wp_dequeue_style('bubblepopup');
  }

  // WP Secret SEO
  if ( function_exists( 'wpsecretseo_start_scripts' ) ) {
    remove_action('admin_print_scripts','wpsecretseo_start_scripts');
    remove_action('admin_head','wpsecretseo_start_tabs');
    remove_action('admin_head', 'wpsecretseo_adminhead');
    remove_action('wp_head', 'wpsecretseo_head');
    remove_action('wp_footer', 'wpsecretseo_footerlinks_wpfooter');

  }

  // Adbrite Money Maker Widget
  if ( function_exists( 'widget_adbrite_color_changer_init' ) ) {
    remove_action('admin_head','add_ui_files');
  }

}

function dab_progressbar_styles() {
  wp_enqueue_style('jquery-ui-lightness');
  wp_enqueue_style('jquery-ui-progressbar');
}

function dab_remove_broken_tinymce_plugins( $plugins ) {
  if ( $_GET[ 'page'] == 'dab_blast' ) {
    unset( $plugins[ 'naffTags' ] ); // Max Blog Press Ninja Aff links
    unset( $plugins[ 'cforms' ] );
  }
  return $plugins;
}

function dab_remove_broken_tinymce_buttons( $buttons ) {
  if ( $_GET[ 'page' ] == 'dab_blast' ) {
    foreach ( $buttons as $key => $button ) {
      // Max Blog Press Ninja Aff links
      if ( $button ==  'naffTags' ) unset( $buttons[ $key ] );
    }
  }
  return $buttons;
}

# TODO: Display a warning if accounts haven't been setup.

function dab_add_action_link( $links, $file ) {
  if ( dirname( WP_PLUGIN_DIR . '/' . $file ) == dirname( __FILE__ ) ) {
    $settings_link = '<a href="' . DAB_ADMIN_URL . '">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  }

  return $links;
}

function dab_page_box() {
  global $post, $post_type_object;
  $blasted = get_post_meta( $post->ID, DAB_META_KEY, true );

  $instance = DAB_MultiCurl::instance();
  if ( !$instance->is_done() ) {
    if ( $instance->post_id ) {
      $url = "admin.php?page=dab_blast";

      if ( isset( $_GET['debug'] ) )
        $url .= "&debug=1";

      $url = admin_url( $url );
    }
    else {
      $url = DAB_ADMIN_URL;
    }

    echo "Digi Article Blaster is busy - <a href=\"$url\" target=\"_blank\">click here to view progress.</a>";
    return;
  }

  $value = "Spin and Blast Article";
  if ( $blasted ) {
      $value .= " Again" ;?>
    <p>This <?php echo $post->post_type ?> has already been blasted.</p>
<?php
  }

  echo '<input name="dab_blast" type="submit" class="button-primary" value="' . $value . '" />';
  if ( isset( $_GET['dab_force'] ) || $blasted )
    echo '<input name="dab_force" value="1" type="hidden" />';
  if ( isset( $_GET['debug'] ) )
    echo '<input name="debug" value="1" type="hidden" />';
}

function dab_check_for_blast_post( $location, $post_id ) {
  // If they clicked the 'Blast Article! button send them to the spin page
  if ( isset( $_POST['dab_blast'] ) ) {
    $url = "admin.php?page=dab_blast&post=$post_id";

    if ( isset( $_POST['dab_force'] ) )
      $url .= "&dab_force=1";

    if ( isset( $_POST['debug'] ) )
      $url .= "&debug=1";

    return admin_url( $url );
  }
  return $location;
}


//----------------------------------------------------------------------------

function dab_inactive_warning() {
  $options = get_option( DAB_OPTIONS_KEY );
  $site_list_ver = get_option( DAB_SITE_LIST_VERSION_KEY, 0);

  if ( !function_exists( 'curl_multi_init' ) ) { ?>
  <div id="message" class="error">
    <p><strong>Digi Article Blaster is not active.</strong> Your PHP does not
    support multi cURL. Please speak to your hosting provider to get it
    enabled.</p>
  </div>
<?php
  }
  elseif ( empty( $options[ 'decaptcha_user' ] ) ) {
?>
  <div id="message" class="error">
    <p><strong>Digi Article Blaster is not active.</strong> You must
    <a href="<?php echo DAB_ADMIN_URL ?>">set up a captcha service</a>
    before it can work.</p>
  </div>
<?php
  }
  elseif ( $site_list_ver != 0 && $site_list_ver < DAB_SITE_LIST_VERSION ) { ?>
  <div class="updated">
    <p><strong>Digi Article Blaster has updated its list of article directories.</strong>
    Please go to the <a href="<?php echo DAB_ADMIN_URL ?>">settings page</a> to
    create new accounts.</p>
  </div>
<?php
  }
}



//----------------------------------------------------------------------------
//
// Filter where we redirect to after posting the options page - this is how we
// have the Create Accounts button do things. The flow is:
//
// if target url was our settings page && POST create_acounts=1
// -> go to our page with &create_accounts=1&noheader=true
// -> this redirects back to the basic page after enqueuing work.
add_filter( 'wp_redirect', 'dab_options_page_redirect_adjuster', 99, 2);
function dab_options_page_redirect_adjuster( $location, $stats ) {
  if ( preg_match( '/admin.php\?page=' . DAB_OPTIONS_KEY. '(&debug=.*?)?&(settings-)?updated=true/', $location, $matches ) &&
       $_POST['create_accounts'] )
  {
    return DAB_ADMIN_URL . $matches[1] . '&create_accounts=1&noheader=true';
  }
  return $location;
}

function dab_options_page() {

  if ( $_GET['create_accounts'] ) {

    if ( DAB_MultiCurl::instance()->is_done() ) {
      $i = 0;
      $batch = DAB_MultiCurl::new_batch();
      foreach ( dab_get_random_sites( 400 ) as $url => $class ) {
        $site = new $class( $url );
        $batch->_enqueue( array( $site, 'signup' ) );
        if ( ( (++$i) % DAB_CONCURRENCY ) == 0 ) {
          $batch->store();
          $batch = DAB_MultiCurl::new_batch();
        }
      }
      # Store anhything left over
      if ( !$batch->is_done() ) $batch->store();
      $working = true;
    }
    update_option( DAB_SITE_LIST_VERSION_KEY, DAB_SITE_LIST_VERSION );
    $url = DAB_ADMIN_URL;
    if ( $_GET['debug'] ) $url .= '&debug=' . $_GET['debug'];

    # We hopefully got here via noheader=true so can redirect now.
    wp_redirect( $url );
    exit();
  }

  # Version of the site list that accounts have been created for.
  $site_list_ver = get_option( DAB_SITE_LIST_VERSION_KEY, 0 );
  $values = get_option( DAB_OPTIONS_KEY, array() );

  # Check the memory limit.
  $mem_limit = trim( ini_get( 'memory_limit' ) );
  switch( strtolower( $mem_limit[ strlen($mem_limit) - 1 ] ) ) {
    // The 'G' modifier is available since PHP 5.1.0
    case 'g':
        $mem_limit *= 1024;
    case 'm':
        $mem_limit *= 1024;
    case 'k':
        $mem_limit *= 1024;
  }

  $mem_limit /= (1024*1024);
?>

<script type="text/javascript">
//<![CDATA[
  jQuery( function() {
    jQuery( '#poststuff .inner-sidebar' )
      .keep_in_view( 20 )
      .append_sidebar_ad( 'digiarticleblaster' );
  } );
//]]>
</script>

<div class="wrap">
  <div id="icon-options-general" class="icon32"><br /></div>
  <h2>Digi Article Blaster &mdash; Settings</h2>

  <?php if ( $mem_limit < 64 ) { ?>
    <div class="updated">
      <p><strong>We recommend a minimum PHP memory limit of 64M to use Digi
      Article Blaster. Your host only has <?php printf('%d', $mem_limit) ?>M
      available.</strong> If you notice any problems please contact your host
      and ask them to increase the memory allocation for your server.</p>
    </div>

<?php
  }
  if ( ( isset( $_GET[ 'updated' ] ) && $_GET[ 'updated' ] == 'true' )
          || ( isset( $_GET[ 'settings-updated' ] ) && $_GET[ 'settings-updated' ] == 'true' ) ) : ?>
    <div id="setting-error-settings_updated" class="updated settings-error">
      <p><strong>Settings saved.</strong></p>
    </div>
  <?php endif; ?>

  <form method="post" action="options.php">
    <?php settings_fields( DAB_OPTIONS_KEY ); ?>
    <?php do_settings_sections( DAB_OPTIONS_KEY ); ?>

    <div id="poststuff" class="metabox-holder has-right-sidebar">
      <div class="inner-sidebar">

        <div class="stuffbox">
          <h3>Save</h3>
          <div class="submitbox">
            <div id="major-publishing-actions">
              <div id="publishing-action">
                <input type="submit" class="button-primary" value="Save Changes" />
              </div>
              <div class="clear"></div>
            </div>
          </div>
        </div>

        <div class="stuffbox">
          <h3>Help</h3>
          <div class="submitbox">
            <div class="inside">
              <p><a href="http://www.digiarticleblaster.com/manual" target="_blank">
                Download the Digi Article Blaster manual</a></p>
              <p><a href="mailto:support@digiarticleblaster.com">
                Email our support team</a></p>
            </div>
          </div>
        </div>

        <div class="stuffbox">
          <h3>Promote</h3>
          <div class="submitbox">
            <div class="inside">
              <p>Earn 60% commission straight to your PayPal account by
              <a href="http://www.digiresults.com/marketplace/952" target="_blank">
              promoting Digi Article Blaster</a> through DigiResults.</p>
            </div>
          </div>
        </div>

        <div class="stuffbox">
          <h3>Run out of articles?</h3>
          <div class="submitbox">
            <div class="inside">
              <p>Run out of articles to blast and have better things to do with
              your time than write more?</p>

              <p>Green Light Articles can write high quality articles from
              $0.015 per word. 100% unique content.</p>

              <p><a href="http://www.greenlightarticles.com/likes/310" target="_blank">Find out more now!</a></p>

            </div>
          </div>
        </div>

      </div>
      <div id="post-body">
        <div id="post-body-content">

          <div class="stuffbox">
            <h3>Captcha Busting Service Credentials </h3>
            <div class="inside">
              <p>In order to sign up to accounts for article directories we
              will need to be able to complete captchas automatically. Some
              directories also require captchas for login.</p>

              <p>Please select your captcha busting service and enter your
              credentials:</p>

              <table class="form-table" style="width: 100%;" cellspacing="2" cellpadding="5">
                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="captcha_service_provider">Provider</label>
                  </th>
                  <td>
                    <select id="captcha_service_provider" name="digiarticleblaster_options[decaptcha_provider]">
                      <option value="">Choose one…</option>
                      <?php foreach ( array( 'Bypass CAPTCHA'/*, 'Beat Captchas'*/, 'Death by Captcha', 'Decaptcher' ) as $s ) {
                        $selected = ( isset( $values[ 'decaptcha_provider' ] ) && $values[ 'decaptcha_provider' ] == $s )
                                  ? 'selected="selected"'
                                  : '';
                        echo "<option value=\"{$s}\" {$selected}>{$s}</option>";
                      } ?>
                    </select>
                  </td>
                </tr>

                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="captcha_service_user">Username</label>
                  </th>
                  <td>
                    <input type="text" id="captcha_service_user" name="digiarticleblaster_options[decaptcha_user]"
                           value="<?php echo htmlspecialchars( $values[ 'decaptcha_user' ] ); ?>"/>
                  </td>
                </tr>
                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="captcha_service_pass">Password</label>
                  </th>
                  <td>
                    <input type="password" id="captcha_service_pass" name="digiarticleblaster_options[decaptcha_pass]"
                           value="<?php echo htmlspecialchars( $values[ 'decaptcha_pass' ] ); ?>"/>
                  </td>
                </tr>
              </table>

              <p id="dab-captcha-check">
                <input type="button" class="button-secondary" value="Check credentials" />
                <span class="message"></span>
              </p>

              <script>
                function captcha_provider_field_changes( val ) {
                  jQuery( "#dab-captcha-check" ).hide();
                  switch ( val ) {
                    case "":
                      jQuery( "#captcha_service_pass, #captcha_service_user" ).parents( 'tr' ).hide();
                      break;
                    case "Beat Captchas":
                    case "Bypass CAPTCHA":
                      jQuery( "label[for=captcha_service_user]" ).text( 'Key' );
                      jQuery( "#captcha_service_pass" ).parents( 'tr' ).hide();
                      jQuery( "#captcha_service_user" ).parents( 'tr' ).show();
                      break;
                    default:
                      jQuery( "label[for=captcha_service_user]" ).text( 'Username' );
                      jQuery( "#captcha_service_pass, #captcha_service_user" ).parents( 'tr' ).show();
                      break;
                  }
                  jQuery( "#captcha_service_user" ).keyup();
                }

                function dab_check_visivblity() {
                  var $ = jQuery,
                      check = $( '#dab-captcha-check input' );

                  // Reset the check message/class
                  check.parent().removeClass( 'failed finished' );
                  check.removeAttr('disabled');
                  check.next( '.message' ).text( '' );

                  if ( $( this ).val() != '' )
                    check.parent().show();
                  else
                    check.parent().hide();
                };

                jQuery( "#captcha_service_user" ).keyup( dab_check_visivblity ).change( dab_check_visivblity );

                var provider = jQuery("#captcha_service_provider");
                provider.change( function () {
                  jQuery( "#captcha_service_user, #captcha_service_pass" ).val( '' );
                  captcha_provider_field_changes( jQuery( this ).val() )
                } );
                captcha_provider_field_changes( provider.val() );

                jQuery( '#dab-captcha-check input' ).click( function() {
                  var $ = jQuery,
                      $this = $( this ),
                      $message = $this.next( '.message' ),
                      provider = $( "#captcha_service_provider" ).val(),
                      be_patient;

                  $this.attr( 'disabled', 'disabled' );
                  $this.parent().removeClass( 'finished failed' ).addClass( 'loading' );
                  $message.text( '' );

                  jQuery.ajax( {
                    url: ajaxurl,
                    data: {
                      'action': 'dab_test_captcha',
                      'provider': provider,
                      'user': $( '#captcha_service_user' ).val(),
                      'pass': $( '#captcha_service_pass' ).val()
                    },
                    type: 'POST',
                    success: function( json ) {
                      window.clearTimeout( be_patient );

                      if ( json.balance ) {
                        $this.parent().removeClass( 'loading' ).addClass( 'finished' );
                        $message.html( 'Your balance is ' + json.balance );
                      }
                      else {
                        $this.parent().removeClass( 'loading' ).addClass( 'failed' );
                        if ( json[ 'error' ] )
                          $message.html( provider + ' said: ' + json[ 'error' ]  );
                        else
                          $message.html( 'Error getting balance; please check your config and try again'  );
                      }

                      $this.removeAttr( 'disabled' );
                    },
                    error: function() {
                      $this.parent().removeClass( 'loading' ).addClass( 'failed' );
                      window.clearTimeout( be_patient );
                      $message.html( 'Error getting balance; please check your config and try again' );
                    }
                  } );

                  // set up a "Please be patient" message to appear after 3 seconds
                  be_patient = window.setTimeout( function() {
                    $message.html( 'Please wait; Digi Article Blaster is checking your credentials' );
                  }, 3000 );

                } );


              </script>
            </div>
          </div>

          <div class="stuffbox">
            <h3>Author Profile</h3>
            <div class="inside">

              <table class="form-table" style="width: 100%;" cellspacing="2" cellpadding="5">
                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="pen_name">Pen Name</label>
                  </th>
                  <td>
                    <input type="text" id="pen_name" name="digiarticleblaster_options[pen_name]" value="<?php echo htmlspecialchars( $values[ 'pen_name' ] ) ?>"/>
                  </td>
                </tr>

                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="email">Email Address</label>
                  </th>
                  <td>
                    <input type="text" id="email" name="digiarticleblaster_options[email]" value="<?php echo htmlspecialchars( $values[ 'email' ] ) ?>"/>
                    <p><strong style="color:#fd0000">Warning:</strong> the article directories will
                    send emails to this address. We recommend creating a new
                    GMail account for this purpose.</p>
                  </td>
                </tr>
              </table>
            </div>
          </div>

<?php if ( $values[ 'decaptcha_user' ] && $values[ 'email' ] ) {
        $count = DAB_Account::num_working_sites();

        $instance = DAB_MultiCurl::instance();
?>
<?php     if ( !$instance->is_done() && !$instance->post_id ) {
            dab_worker_stuffbox(
              "Accounts",
              "Digi Article Blaster is creating accounts for you &#8212; please be patient.",
              "Thank you. Please refresh this page."
              // "<strong>Please check your email:</strong> some sites will need you to click a confirmation link before they can be used."
            );
          }
          else { ?>

          <div class="stuffbox">
            <h3>Accounts</h3>
            <div class="inside">
<?php         if ( !$count ) { ?>
                <input style="float:right" type="submit" name="create_accounts" class="button-primary" value="Create Accounts" />
<?php         } ?>
              <p style="line-height:20px">You currently have <?php echo $count ?> account<?php if ( $count != 1 ) echo 's'; ?>.</p>
<?php         if ( $count && $site_list_ver < DAB_SITE_LIST_VERSION ) { ?>
                <input style="float:right" type="submit" name="create_accounts" class="button-primary" value="Create New Accounts" />
                <p style="line-height:20px">There is an updated list of article directories - click the button to create accounts on them.</p>
<?php         }
              elseif ( $count ) { ?>
                <div id="dab_nuke_accounts" class="hide-if-no-js">
                  <input type="button" name="create_accounts" class="button" value="Reset accounts and start again" />
                  This action is permanent and cannot be undone.
                  <script>
                    jQuery("#dab_nuke_accounts input").click( function () {
                      var $ = jQuery;

                      if (!confirm( 'Reset accounts and start again?\n\nIf you click OK all the accounts will be deleted and you will have to register for new accounts on all directories.\n\nThis step cannot be undone once you press OK\n') )
                        return false;

                      $(this).attr('disabled','disabled');
                      jQuery.ajax( {
                        url: ajaxurl,
                        data: { 'action': 'dab_nuke_accounts', 'do': 1 },
                        type: 'GET',
                        success: function( ) {
                          // Force a refresh
                          window.location = location;
                        },
                        error: function() {
                          $(this).parent().html( "We're sorry but something went wrong. Please refresh and try again. If the problem persists please contact <a href=\"mailto:support@digiarticleblaster.com\">support@digiarticleblaster.com</a>.");
                        }
                      } )
                      return false;
                    } );
                  </script>
                </div>
                <?php         } ?>
            </div>
          </div>
<?php     } ?>
<?php } ?>
        </div>
      </div>
    </div>
  </form>
</div>
<?php
}




//----------------------------------------------------------------------------
global $dab_cycle_counter;
$dab_cycle_counter = 0;

function dab_cycle() {
  global $dab_cycle_counter;

  $args = func_get_args();
  $i = $dab_cycle_counter < count( $args ) ? $dab_cycle_counter : 0;
  $value = $args[ $i ];

  $dab_cycle_counter = $i + 1;

  return $value;
}

//----------------------------------------------------------------------------

function dab_filter_line_endings( $str ) {

  # Some directories don't respect h2/paras despite using the html editor, so
  # to play it safe put a double line break after some elements
  $str = preg_replace( '/(<\/(?:p|h2|h3|div)>)/', "$1\n\n", $str );
  $str = preg_replace( '/(?<!\r)\n/', "\r\n", $str );
  return trim( $str );
}

// Queues up an article to be blasted
function dab_blast_article( $post_id, $title, $category, $content, $bio, $site_ids = NULL ) {

  # Setup the store of what we have attempted with this article.
  add_post_meta( $post_id, DAB_META_KEY, serialize( array() ), true );

  if ( $site_ids )
    $sites = array_filter( array_map( array( 'DAB_Account', 'find' ), $site_ids ) );
  else
    $sites = DAB_Account::all_sites();

  dab_debug( "Blasting to " . count($sites) );

  $batch = DAB_MultiCurl::new_batch( $post_id );
  foreach( $sites as $i => $site ) {
    $article = new stdClass();
    $article->title = apply_filters( 'dab_article_title', $title );
    $article->content = apply_filters( 'dab_article_text', $content );
    $article->bio = apply_filters( 'dab_article_bio', $bio );

    $article->category = $category;
    $article->post_id = $post_id;

    $batch->_enqueue(
      array( $site, 'submit_article' ),
      array( $article )
    );
    if ( $i != 0 && ( $i % DAB_CONCURRENCY ) == 0 ) {
      dab_debug($i);
      $batch->store();
      $batch = DAB_MultiCurl::new_batch( $post_id );
    }
  }
  # Store anhything left over
  if ( !$batch->is_done() ) $batch->store();

}




//----------------------------------------------------------------------------
function dab_worker_stuffbox( $title, $msg, $completed_msg, $complete_cb = null ) { ?>
        <div class="stuffbox"  id="dab-worker">
          <h3><?php echo $title ?></h3>
          <div class="inside">
            <p class="dab-please-wait" style="font-size: 250%; font-weight: bold">Please stay on this page until the work is done.</p>
            <p class="dab-msg"><?php echo $msg ?></p>
            <div id="progressbar"></div>
            <div class="faux-label" style="margin: 6px 6px 8px">Activity Log:</div>
            <textarea class="status" style="width:100%" rows="25" readonly="readonly"></textarea>
            <script>
              jQuery(function($) {
                $.ajaxSetup({ cache: false });
                var pbar = $( "#progressbar" ).progressbar({ value: 1 }),
                    status = $("#dab-worker textarea.status"),
                    total_work = undefined,
                    work_done = 0;

                args = { 'action': 'dab_do_work', 'do': 1 };
<?php           if ( $_GET['debug'] ) { ?>
                args.debug = 1;
<?php           } ?>

                var cb = function( json ) {
                  if ( total_work === undefined ) total_work = json.total_work;

                  work_done += json.work_done;

                  if ( json.log.length > 1 || json.log[0] != "" ) {
                    var log = json.log.reverse().join( "\r\n" );
                    status.val( log + "\r\n" + status.val() );
                  }

                  // Make sure it always show at least 1%
                  pbar.progressbar( { value: work_done/total_work * 100 || 1 } );
                  if ( json.more_to_do ) {
                    $.getJSON( ajaxurl, args, cb );
                  }
                  else {
                    pbar.slideUp();
                    $( "#dab-worker p.dab-msg").html( "<?php echo addslashes($completed_msg) ?>" );
                    $( "#dab-worker p.dab-please-wait").html( "Work completed - you can now navigate elsewhere." );
                    <?php if ($complete_cb) echo "$complete_cb();\n" ?>
                  }
                };

                $.getJSON( ajaxurl, args, cb );
              });
            </script>
          </div>
        </div>
<?php
}


// Scripts/styles for the Blast Post page. Everything we need to the wysiwyg edit box.
function dab_admin_blast_scripts() {
  wp_enqueue_script('post');
  if ( user_can_richedit() )
    wp_enqueue_script('editor');
  wp_enqueue_script('word-count');
  wp_enqueue_script('jquery');
  wp_enqueue_script('quicktags');
  add_action( 'admin_print_footer_scripts', 'wp_tiny_mce', 25 );
  add_action( 'admin_print_footer_scripts', 'wp_tiny_mce_preload_dialogs', 30 );

}

function dab_admin_blast_styles() {
  wp_enqueue_style( 'dab_admin' );
}

function dab_spin_error_context( $text ) {
  preg_match( '/.{0,20}[{}].{0,20}/', $text, $m );
  return htmlspecialchars( $m[0] );
}

// The POST action for dab_blast_page
function dab_blast_action( $post ) {

  $_POST = array_map( 'stripslashes_deep', $_POST );

  $errors = array();
  if ( !$_POST['title'] ) {
    $errors[] = 'Article title cannot be blank';
  }

  // Check for unbalanced spinning
  $spun = DAB_Spinner::spin( $_POST['title'] );
  if ( strpos( $spun, '{' ) !== false || strpos( $spun, '}' ) !== false )
    $errors[] = 'There was a problem with your spin tags in the article title near <kbd>' . dab_spin_error_context($spun) . '</kbd>. Please correct it and try again';
  $spun = DAB_Spinner::spin( $_POST['content'] );
  if ( strpos( $spun, '{' ) !== false || strpos( $spun, '}' ) !== false )
    $errors[] = 'There was a problem with your spin tags in the article body near <kbd>' . dab_spin_error_context($spun) . '</kbd>. Please correct it and try again.';
  $spun = DAB_Spinner::spin( $_POST['bio'] );
  if ( strpos( $spun, '{' ) !== false || strpos( $spun, '}' ) !== false )
    $errors[] = 'There was a problem with your spin tags in the author bio near <kbd>' . dab_spin_error_context($spun) . '</kbd>. Please correct it and try again';

  if (count($errors)) {
    return "<p>" . implode('</p><p>', $errors) . "</p>";
  }

  $title = $_POST['title'];
  $category = $_POST['category'];
  $content = $_POST['content'];
  $bio = $_POST['bio'];
  $site_ids = $_POST['sites'];
  $permalink = get_permalink( $post->ID );

  if ( !$bio )
    $bio = "Source: <a href=\"$permalink\">$title</a>";

  dab_blast_article( $post->ID, $title, $category, $content, $bio, $site_ids );
  dab_show_blast_worker_page( $post->ID );
}

function dab_show_blast_worker_page( $post_id ) {
?>
<div class="wrap">
  <div id="icon-options-general" class="icon32"><br /></div>
  <h2>Blasting &mdash; Please Wait</h2>

  <div id="poststuff" class="metabox-holder">

    <div id="post-body">
      <div id="post-body-content">
<?php     $count = DAB_Account::num_accounts();
          dab_worker_stuffbox(
            "Submitting Articles",
            "Digi Article Blaster is working.",
            "Fetching auto-approved URLs…",
            "dab_show_autoapprove_urls"
          );
        ?>
      <script>
        function dab_show_autoapprove_urls() {
          var $ = jQuery;
          $.ajaxSetup({ cache: false });

          args = { 'action': 'dab_view_article_urls', 'post': <?php echo $post_id ?> };
<?php     if ( $_GET['debug'] ) { ?>
          args.debug = 1;
<?php     } ?>

          $.get( ajaxurl, args, function( json ) {
            var status = $("#dab-worker textarea.status"),
                lbl = $("#dab-worker .faux-label");

            lbl.slideUp();
            status.slideUp( 400, function() {

              var urls = json.urls.reverse().join( "\r\n" );
              status.val( urls );
              lbl.text( "URLs of autoapproved articles (" + json.urls.length + "):" );
              status.slideDown();
              lbl.slideDown();
              var msg = "Your article was submitted to " + json.count;

              if (json.count == 1) msg += " directory";
              else                 msg += " directories";

              $( "#dab-worker p.dab-msg").text( msg );
            } )

          } );
        }
      </script>
      </div>
    </div>
  </div>
</div>
<?php
  exit();
}

function dab_blast_page() {
  global $current_screen;

  $instance = DAB_MultiCurl::instance();
  if ( !$instance->is_done() ) {
    dab_show_blast_worker_page( $instance->post_id );
  }


  if ( isset($_GET['post']) )
    $post_id = (int) $_GET['post'];
  elseif ( isset($_POST['post_ID']) )
    $post_id = (int) $_POST['post_ID'];
  else
    $post_id = 0;

  if ( empty( $post_id ) ) {
    wp_redirect( admin_url('post.php') );
    exit();
  }

  $post = get_post($post_id);
  if ( $post ) {
    $post_type_object = get_post_type_object($post->post_type);
    if ( $post_type_object ) {
      $current_screen->post_type = $post->post_type;
      $current_screen->base = 'edit';
    }
  }

  if ( empty( $post ) ) {
    wp_redirect( admin_url('post.php') );
    exit();
  }

  # Check if we have already blasted this article?
  $blasted = @unserialize( get_post_meta( $post_id, DAB_META_KEY, true ) );

  if ( $blasted && !isset( $_GET['dab_force'] ) ) {
    ?>
<div class="wrap">
  <?php screen_icon(); ?>
  <h2>Blast <?php echo $post_type_object->labels->singular_name ?></h2>
  <div id="notice" class="error"><p>This <?php echo $post_type_object->labels->singular_name ?> has already been blasted.</p></div>
<?php
    exit;
  }


  if ($_SERVER['REQUEST_METHOD'] == "POST") {
    # If this returns there was an error with the form
    $notice = dab_blast_action( $post );
  }

  if ( count( $_POST ) ) {
    $values = $_POST;
  }
  else {
    $title = $post->post_title;
    $permalink = get_permalink( $post->ID );

    $values = array(
      'title' => $title,
      'bio' => "Source: <a href=\"$permalink\">$title</a>",
      'content' => $post->post_content
    );
  }


  ?>
<div class="wrap">

  <?php screen_icon(); ?>
  <h2>Blast <?php echo $post_type_object->labels->singular_name ?></h2>

  <?php if ( $notice ) { # Display error notices ?>
  <div id="notice" class="error"><p><?php echo $notice ?></p></div>
  <?php } ?>

  <form method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
    <div id="poststuff" class="metabox-holder has-right-sidebar">
      <div class="inner-sidebar">

        <div class="stuffbox">
          <h3>Blast!</h3>
          <div class="submitbox">
            <div id="major-publishing-actions">
              <div id="publishing-action">
                <input type="submit" class="button-primary" value="Blast to Directories" />
              </div>
              <div class="clear"></div>
            </div>
          </div>
        </div>
      </div>

      <div id="post-body">
        <div id="post-body-content">

        <p>You can spin the title, content and the bio by using the
        <kbd>{option|alternatives|posibilites}</kbd> syntax in the boxes below.
        You can also get <a href="http://www.greenlightarticles.com/likes/310">Green
        Light Articles</a> to spin your articles for you.</p>


          <div class="stuffbox">
            <h3>About the Article</h3>
            <div class="inside">

              <table class="form-table" style="width: 100%;" cellspacing="2" cellpadding="5">
                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="title">Title</label>
                  </th>
                  <td>
                    <input type="text" id="title" name="title" value="<?php echo htmlspecialchars( $values[ 'title' ] ) ?>"/>
                  </td>
                </tr>

                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="category">Category</label>
                  </th>
                  <td>
                    <select id="category" name="category">
                      <option value="">Random</option>
                      <?php foreach ( dab_possible_categories() as $val => $txt ) {
                        $selected = ( isset( $values[ 'category' ] ) && $values[ 'category' ] == $val )
                                  ? 'selected="selected"'
                                  : '';
                        echo "<option value=\"{$val}\" {$selected}>{$txt}</option>";
                      } ?>
                    </select>
                    <p>Not all directories have all these cateogories —
                    Digi&nbsp;Article&nbsp;Blaster will attempt to find the best
                    match for the one you select.</p>
                  </td>
                </tr>
<?php           if ( $_GET['debug'] ) { ?>

                <tr class="form-field">
                  <th valign="top" scope="row" style="padding-top: 14px;">
                    <label for="sites">Site</label>
                  </th>
                  <td>
                    <select id="sites" name="sites[]" multiple="multiple" style="height: 10em">
                      <?php
                        $sites = DAB_Account::all_sites( 'id' );
                        foreach ( $sites as $site ) {
                        echo "<option value=\"{$site->id}\">{$site->id} — " . htmlspecialchars( $site->root ) . "</option>";
                      } ?>
                    </select>
                  </td>
                </tr>
<?php           } ?>
              </table>

            </div>
          </div>

          <div id="<?php echo user_can_richedit() ? 'postdivrich' : 'postdiv'; ?>" class="postarea">

            <?php the_editor( $values[ 'content' ] ); ?>

            <table id="post-status-info" cellspacing="0"><tbody><tr>
              <td id="wp-word-count"></td>
            </tr></tbody></table>

          </div>


          <div class="stuffbox">
            <h3>Author Bio</h3>
            <div class="customEditor">
              <textarea class="author_bio" id="excerpt" name="bio" rows="1" cols="40"><?php echo htmlspecialchars( $values['bio'] ) ?></textarea>
            </div>
            <div class="inside">
              <p>Contents for the 'About the Author' box. Leave it empty for the
              default behaviour of incuding just a permalink to the post.</p>
            </div>

          </div>
        </div>
      </div>
    </div>
  </form>
</div>
  <?php
}

add_action('admin_footer-admin_page_dab_blast', 'dab_blast_page_footer_scripts');
function dab_blast_page_footer_scripts() {
  ?><script type="text/javascript">/* <![CDATA[ */
    jQuery( function($) {

    $( '#poststuff .inner-sidebar' ).keep_in_view( 20 )

      var i = 1;
      $('.customEditor textarea').each( function(e) {
        var id = $(this).attr('id');

        if (!id) {
          id = 'customEditor-' + i++;
          $(this).attr('id',id);
        }
        tinyMCE.execCommand('mceAddControl', false, id);
      } );
    } );
  /* ]]> */</script><?php
}

function dab_get_random_sites( $n ) {
  global $dab_all_sites, $wpdb;
  $out = array();

  $current = $wpdb->get_col( "SELECT url FROM {$wpdb->prefix}dab_accounts" );

  $keys = array_diff( array_keys( $dab_all_sites ), $current );
  shuffle( $keys );

  $n = min( sizeof( $keys ), $n );
  for ($i = 0; $i <  $n; $i++ ) {
    $out[ $keys[ $i ] ] = $dab_all_sites[ $keys[ $i ] ];
  }

  return $out;
}


// When adding sites here, update this once before releasing, and make sure
// any sites added to the list *do not* have trailing slashes
define( 'DAB_SITE_LIST_VERSION', 2 );

global $dab_all_sites;
$dab_all_sites = array(
  // 'http://101info.org/pcimarticles' => 'DAB_ArticleMS', # Not appropriate
  // 'http://addicted2jesus.com/meditate' => 'DAB_ArticleMS',
  // 'http://alexlindsay.info' => 'DAB_ArticleMS', // Bad config
  'http://all-about-printing.com' => 'DAB_ArticleMS',
  'http://alltopicarticles.com' => 'DAB_ArticleMS',
  'http://ar.nichehosts.com' => 'DAB_ArticleMS',
  'http://article.crazynet4u.com' => 'DAB_ArticleMS',
  'http://articlefuse.com' => 'DAB_ArticleMS',
  // 'http://articleknowledgebase.com' => 'DAB_ArticleMS',
  'http://articleline.net' => 'DAB_ArticleMS',
  'http://articles.datditdutdet.com' => 'DAB_ArticleMS',
  'http://articlesuseful.com' => 'DAB_ArticleMS',
  'http://articlevie.com' => 'DAB_ArticleMS',
  'http://auto-submitters.com/1023' => 'DAB_ArticleMS',
  'http://biglerarticler.net' => 'DAB_ArticleMS',
  'http://bluewaterarticles.com' => 'DAB_ArticleMS',
  'http://contentcountry.com' => 'DAB_ArticleMS',
  'http://dhsphoto.co.uk/Articles' => 'DAB_ArticleMS',
  'http://dimontefiano.net/DiMF_Articles_articlems_2_0_Amarcord' => 'DAB_ArticleMS',
  // 'http://draftingservice.us/drafting' => 'DAB_ArticleMS', # Not appropriate
  'http://eazyarticles.com' => 'DAB_ArticleMS',
  'http://ezine-article-exchange.com' => 'DAB_ArticleMS',
  'http://factsvault.com' => 'DAB_ArticleMS',
  'http://firststoponthenet.com' => 'DAB_ArticleMS',
  'http://freearticles2u.com' => 'DAB_ArticleMS',
  'http://greatesthealthsupplements.com' => 'DAB_ArticleMS',
  'http://health.yesti.net' => 'DAB_ArticleMS',
  'http://healthmasterrecipes.com' => 'DAB_ArticleMS',
  'http://imarticles.net' => 'DAB_ArticleMS',
  'http://justwantinfo.com/articlems' => 'DAB_ArticleMS',
  'http://lifeandpeople.com' => 'DAB_ArticleMS',
  'http://mice.org/articlems' => 'DAB_ArticleMS',
  'http://mytoparticles.com' => 'DAB_ArticleMS',
  'http://naturalcity.ca' => 'DAB_ArticleMS',
  'http://outpublish.com' => 'DAB_ArticleMS',
  'http://petarticledirectory.com' => 'DAB_ArticleMS',
  'http://petarticlesonline.com' => 'DAB_ArticleMS',
  'http://petergormanarchive.com/at' => 'DAB_ArticleMS',
  'http://proarticlesdaily.com' => 'DAB_ArticleMS',
  'http://readerspot.com/articles' => 'DAB_ArticleMS',
  'http://receivedtext.org/articles' => 'DAB_ArticleMS',
  'http://thearticleshack.com' => 'DAB_ArticleMS',
  'http://theegarage.com' => 'DAB_ArticleMS',
  'http://timesavinginfo.com' => 'DAB_ArticleMS',
  'http://wees.us' => 'DAB_ArticleMS',
  'http://wfsarticledirectory.com' => 'DAB_ArticleMS',
  'http://writearticles.in' => 'DAB_ArticleMS',
  'http://www.ad-matrix.net' => 'DAB_ArticleMS',
  'http://www.aquariumrank.com/articles' => 'DAB_ArticleMS',
  'http://www.article-marketing.biz' => 'DAB_ArticleMS',
  'http://www.articleentries.info' => 'DAB_ArticleMS',
  'http://www.articlefruits.com' => 'DAB_ArticleMS',
  'http://www.articlemint.com' => 'DAB_ArticleMS',
  'http://www.articlenic.com' => 'DAB_ArticleMS',
  'http://www.articlescolumn.com' => 'DAB_ArticleMS',
  'http://www.articlesdot.com' => 'DAB_ArticleMS',
  'http://www.articlesexplorer.com' => 'DAB_ArticleMS',
  'http://www.articlesinfinite.com' => 'DAB_ArticleMS',
  'http://www.articlesisland.com' => 'DAB_ArticleMS',
  'http://www.articleslibrary.org' => 'DAB_ArticleMS',
  'http://www.articlesoft.com' => 'DAB_ArticleMS',
  'http://www.articlesongolf.com' => 'DAB_ArticleMS',
  'http://www.articlesonlove.com' => 'DAB_ArticleMS',
  'http://www.articlespublisher.com' => 'DAB_ArticleMS',
  'http://www.articlesview.com' => 'DAB_ArticleMS',
  'http://www.articletrader.com' => 'DAB_ArticleMS',
  'http://www.assetinvesting.com/articles' => 'DAB_ArticleMS',
  'http://www.authorpalace.com' => 'DAB_ArticleMS',
  'http://www.avapost.com' => 'DAB_ArticleMS',
  'http://www.bannerblazer.com' => 'DAB_ArticleMS',
  'http://www.bestarticledir.com' => 'DAB_ArticleMS',
  'http://www.billoarticles.com' => 'DAB_ArticleMS',
  'http://www.bioscience.ws/methods' => 'DAB_ArticleMS',
  'http://www.bizboost.info/articles' => 'DAB_ArticleMS',
  'http://www.bjstar.com' => 'DAB_ArticleMS',
  'http://www.bodegamedia.com' => 'DAB_ArticleMS',
  'http://www.boxfon.ru' => 'DAB_ArticleMS',
  'http://www.cellocity.net' => 'DAB_ArticleMS',
  'http://www.clickforseo.com' => 'DAB_ArticleMS',
  'http://www.content-syndication.org' => 'DAB_ArticleMS',
  'http://www.contentcow.biz' => 'DAB_ArticleMS',
  'http://www.contentking.eu' => 'DAB_ArticleMS',
  'http://www.crampuppy.com' => 'DAB_ArticleMS',
  'http://www.dancingarticles.com' => 'DAB_ArticleMS',
  'http://www.datingtipssite.net/articles' => 'DAB_ArticleMS',
  // 'http://www.directoryarticles.com' => 'DAB_ArticleMS', // Submission disabled
  'http://www.dogarticledirectory.net' => 'DAB_ArticleMS',
  'http://www.donanyc.com' => 'DAB_ArticleMS',
  'http://www.donatecharity.net' => 'DAB_ArticleMS',
  'http://www.drawphiladelphia.com' => 'DAB_ArticleMS',
  'http://www.earnfromnet.com/articles4beginners' => 'DAB_ArticleMS',
  'http://www.ezx-articles.com' => 'DAB_ArticleMS',
  'http://www.free-article-submit.com' => 'DAB_ArticleMS',
  'http://www.freearticlepro.com' => 'DAB_ArticleMS',
  'http://www.freearticlesonly.com' => 'DAB_ArticleMS',
  'http://www.freemusicinformationdownloads.com/articles' => 'DAB_ArticleMS',
  'http://www.funcage.com/joke' => 'DAB_ArticleMS',
  'http://www.gardengap.com' => 'DAB_ArticleMS',
  'http://www.goevodir.com' => 'DAB_ArticleMS',
  'http://www.guiding-stars.com/article' => 'DAB_ArticleMS',
  'http://www.healthreleases.com' => 'DAB_ArticleMS',
  'http://www.healthsnare.com' => 'DAB_ArticleMS',
  'http://www.hollywoodmakeupsecrets.com/articles' => 'DAB_ArticleMS', # printview has display:none in front.
  'http://www.hostingwebnet.com' => 'DAB_ArticleMS',
  'http://www.hotarticles.org' => 'DAB_ArticleMS',
  'http://www.indexarticle.com' => 'DAB_ArticleMS',
  'http://www.indiauses.com' => 'DAB_ArticleMS',
  'http://www.informationworldnetwork.com/index.php' => 'DAB_ArticleMS',
  'http://www.informativesource.com' => 'DAB_ArticleMS',
  'http://www.insria.net' => 'DAB_ArticleMS',
  'http://www.interester.com' => 'DAB_ArticleMS',
  'http://www.law-articles.org' => 'DAB_ArticleMS',
  'http://www.learntorre.com' => 'DAB_ArticleMS',
  'http://www.lovethistown.com.au' => 'DAB_ArticleMS',
  'http://www.manipalonline.com' => 'DAB_ArticleMS',
  'http://www.marketingpixels.com/articles' => 'DAB_ArticleMS',
  'http://www.monsieurknowledge.com' => 'DAB_ArticleMS',
  'http://www.morethanarticles.com' => 'DAB_ArticleMS',
  'http://www.mylife9.com' => 'DAB_ArticleMS',
  'http://www.namvarha.com' => 'DAB_ArticleMS',
  // 'http://www.nanobiz.info/articles' => 'DAB_ArticleMS', # Cyrillic
  'http://www.nichesarticle.com' => 'DAB_ArticleMS',
  'http://www.nightskyobserver.com/astroarticles' => 'DAB_ArticleMS',
  'http://www.nouralislam.org/artportugese' => 'DAB_ArticleMS',
  'http://www.oliodigest.com' => 'DAB_ArticleMS',
  'http://www.pagerank-tools.com' => 'DAB_ArticleMS',
  'http://www.pecfest.org' => 'DAB_ArticleMS',
  'http://www.plrarticlessite.com' => 'DAB_ArticleMS',
  'http://www.pool-billiard-accessories.com/billiardarticles' => 'DAB_ArticleMS',
  'http://www.radiotecnicheperfette.com' => 'DAB_ArticleMS',
  'http://www.rainsnet.org' => 'DAB_ArticleMS',
  'http://www.read4me.net' => 'DAB_ArticleMS',
  'http://www.realreadz.com' => 'DAB_ArticleMS',
  'http://www.rebiz.info/articles' => 'DAB_ArticleMS',
  'http://www.recipesupersource.com/recipes' => 'DAB_ArticleMS',
  'http://www.regionalarticles.com' => 'DAB_ArticleMS',
  'http://www.selectivearticles.com' => 'DAB_ArticleMS',
  'http://www.supremearticle.com' => 'DAB_ArticleMS',
  'http://www.tetmarket.com' => 'DAB_ArticleMS',
  'http://www.thearticlestudio.com' => 'DAB_ArticleMS',
  'http://www.theeasyworld.com' => 'DAB_ArticleMS',
  'http://www.theworldneedsyounow.com' => 'DAB_ArticleMS',
  'http://www.thinkgreenarticles.com' => 'DAB_ArticleMS',
  'http://www.titlepublish.com' => 'DAB_ArticleMS',
  'http://www.totheglobe.info' => 'DAB_ArticleMS',
  'http://www.totheworld.info' => 'DAB_ArticleMS',
  'http://www.travelfreeguides.com' => 'DAB_ArticleMS',
  'http://www.urlexpress.net' => 'DAB_ArticleMS',
  'http://www.vegasinfocenter.com/articles' => 'DAB_ArticleMS',
  'http://www.waddyjones.com' => 'DAB_ArticleMS',
  'http://www.whistleronline.ca/articles' => 'DAB_ArticleMS',
  'http://www.whitetailtube.com/deerhuntingarticles' => 'DAB_ArticleMS',
  // 'http://www.wiredbiz.info/articles' => 'DAB_ArticleMS', # Cyrillic
  'http://www.wonder-directory.com' => 'DAB_ArticleMS',
  'http://www.yourdomsite.info' => 'DAB_ArticleMS',
  'http://www.yourvacationtips.com' => 'DAB_ArticleMS',
  // 'http://www.ypyc.com/articles' => 'DAB_ArticleMS', # Cryillic
  'http://articlepusher.com' => 'DAB_ArticleMS',
  'http://thrivingbabies.com/articles' => 'DAB_ArticleMS',
  'http://firstpageseoservices.com/article' => 'DAB_ArticleMS',
  'http://uniquebusinessarticles.com' => 'DAB_ArticleMS',
  'http://www.greenparadise.co.uk' => 'DAB_ArticleMS',
  'http://www.relationshiprepair.net/articlems' => 'DAB_ArticleMS',
  // 'http://www.links7.com' => 'DAB_ArticleMS', # printview doesn't work
  'http://www.articlebeautytips.com' => 'DAB_ArticleMS',
  'http://www.financebusinessarticles.com' => 'DAB_ArticleMS',
  'http://articleszone.org' => 'DAB_ArticleMS',
  'http://publicana.info' => 'DAB_ArticleMS',
  'http://articleace.com' => 'DAB_ArticleMS',
  'http://www.uniquefinancialarticles.com' => 'DAB_ArticleMS',
  'http://qbarticles.com' => 'DAB_ArticleMS',
  'http://www.articleentry.com' => 'DAB_ArticleMS',
  'http://www.netpreneurnow.com/internet-marketing-articles' => 'DAB_ArticleMS',
  'http://articlepaycheck.com' => 'DAB_ArticleMS',
  'http://www.articles2web.com' => 'DAB_ArticleMS',
  'http://articlesme.com' => 'DAB_ArticleMS',
  'http://1whp.com/articles' => 'DAB_ArticleMS',
  'http://www.bigmedicalsite.com' => 'DAB_ArticleMS',
  'http://www.freelinkexchange.biz/article_directory' => 'DAB_ArticleMS',
  'http://www.articlesvalley.com' => 'DAB_ArticleMS',
  'http://www.articlecanyon.com' => 'DAB_ArticleMS',
  'http://www.articopia.com' => 'DAB_ArticleMS',
  'http://arti.motomaniac.info' => 'DAB_ArticleMS',
  'http://ezinepowerpublisher.com' => 'DAB_ArticleMS',
  'http://justmelpublishing.com' => 'DAB_ArticleMS',
  'http://therightarticle.com' => 'DAB_ArticleMS',
  'http://www.sddx.com/index.php' => 'DAB_ArticleMS',
  'http://www.101dogbreeds.com' => 'DAB_ArticleMS',
  'http://www.aeticle.com' => 'DAB_ArticleMS',
  'http://www.crikeydirectory.com/pages' => 'DAB_ArticleMS',
  'http://www.totheplanet.info' => 'DAB_ArticleMS',
  'http://www.property-estateagents.org' => 'DAB_ArticleMS',
  'http://articlewhiteboard.com' => 'DAB_ArticleMS',
  'http://www.uniquegiftsites.co.uk' => 'DAB_ArticleMS',
  'http://www.propertyandinvesting.com/Property-Articles' => 'DAB_ArticleMS',
  'http://ar.nichehosts.com' => 'DAB_ArticleMS',
  'http://legal-articles.deysot.com' => 'DAB_ArticleMS',
  'http://articles.wirek.info' => 'DAB_ArticleMS',
  'http://money.grynt.info' => 'DAB_ArticleMS',
  'http://www.travelarticlesexpress.com' => 'DAB_ArticleMS',
  'http://www.800pressrelease.com/index.php' => 'DAB_ArticleMS',
  'http://www.thatinfofix.com' => 'DAB_ArticleMS',
  'http://asianet-international.com/articles' => 'DAB_ArticleMS',
  'http://wordscity.com' => 'DAB_ArticleMS',
  'http://selectivearticles.com' => 'DAB_ArticleMS',
  'http://www.highprofilearticles.info' => 'DAB_ArticleMS',
  'http://www.linkpostdirectory.com' => 'DAB_ArticleMS',
  'http://hackerreview.com' => 'DAB_ArticleMS',
  'http://www.diyresource.com' => 'DAB_ArticleMS',
  'http://www.nanooarticles.info' => 'DAB_ArticleMS',
  'http://www.jannogcd.com' => 'DAB_ArticleMS',
  'http://www.articlesplace.info' => 'DAB_ArticleMS',
  'http://2karticles.com' => 'DAB_ArticleMS',
  'http://www.doctordrum.com' => 'DAB_ArticleMS',
  'http://www.articlehoopla.com' => 'DAB_ArticleMS',
  'http://www.car-articles.co.uk' => 'DAB_ArticleMS',
  'http://www.articlesurvey.com' => 'DAB_ArticleMS',
  'http://forex-2011.com' => 'DAB_ArticleMS',
  'http://www.articlestraffic.com' => 'DAB_ArticleMS',
  'http://www.monsieurknowledge.com' => 'DAB_ArticleMS',
  'http://www.ahost.ro' => 'DAB_ArticleMS',
  'http://www.shopping-in.org' => 'DAB_ArticleMS',
  'http://www.bitlyrics.com/index.php' => 'DAB_ArticleMS',
  'http://www.articles.goldenwords.info' => 'DAB_ArticleMS',
  'http://www.parentsupersite.com/ad' => 'DAB_ArticleMS',
  'http://mybaby101.info' => 'DAB_ArticleMS',
  'http://www.adviatech.com/articles' => 'DAB_ArticleMS',
  'http://www.articles.howrank.com' => 'DAB_ArticleMS',
  'http://www.my-miniature-pinscher.com/art' => 'DAB_ArticleMS',
  'http://www.nightskyobserver.com/astroarticles' => 'DAB_ArticleMS',
  'http://iamhereonline.com/Articles' => 'DAB_ArticleMS',
  'http://constantcontentsource.com' => 'DAB_ArticleMS',
  'http://www.seoboot.net' => 'DAB_ArticleMS',
  'http://articlesinenglish.com/english_articles' => 'DAB_ArticleMS',
  'http://www.contentguild.com' => 'DAB_ArticleMS',
  'http://www.hostcontent.net/articles' => 'DAB_ArticleMS',
  'http://www.associatedarticles.com' => 'DAB_ArticleMS',
  'http://simarticles.com' => 'DAB_ArticleMS',
  'http://articlegazette.silmarwen.com' => 'DAB_ArticleMS',
  'http://www.pokercontentonline.com' => 'DAB_ArticleMS',
  'http://www.forexarticlecollection.com' => 'DAB_ArticleMS',
  'http://articlerw.com' => 'DAB_ArticleMS',
  'http://www.1morearticle.com' => 'DAB_ArticleMS',
  'http://www.boat-dealers.us/articles' => 'DAB_ArticleMS',
  'http://businessarticlesdirectory.com' => 'DAB_ArticleMS',
  'http://www.hr-training.com' => 'DAB_ArticleMS',
  'http://articlesgateway.com' => 'DAB_ArticleMS',
  'http://www.diygardeningtips.com' => 'DAB_ArticleMS',
  'http://www.eatsee.com' => 'DAB_ArticleMS',
  'http://www.wahoptions.com/articles' => 'DAB_ArticleMS',
  'http://www.emcnc.ru' => 'DAB_ArticleMS',
  'http://www.catnews.org/article' => 'DAB_ArticleMS',
  'http://society.andreks.com' => 'DAB_ArticleMS',
  'http://articles.jainsachin.com' => 'DAB_ArticleMS',
  'http://artikelhaus.de' => 'DAB_ArticleMS',
  'http://readaboutitnow.com' => 'DAB_ArticleMS',
  'http://big-site.info' => 'DAB_ArticleMS',
  'http://articles.fjewelrystore.com' => 'DAB_ArticleMS',
  'http://psychicregister.com' => 'DAB_ArticleMS',
  'http://cornenergysystems.com/environmental-articles' => 'DAB_ArticleMS',
  'http://www.free-articles.neutronmarketing.com' => 'DAB_ArticleMS',
  'http://articleanvil.com' => 'DAB_ArticleMS',
  'http://zuze.org/articles' => 'DAB_ArticleMS',
  'http://www.easyforexstrategy.com' => 'DAB_ArticleMS',
  'http://articles.mysticdragonorb.com' => 'DAB_ArticleMS',
  'http://que-passa.piniol.com' => 'DAB_ArticleMS',
  'http://worldsoapbox.com/articles' => 'DAB_ArticleMS',
  'http://mily.vermit.net' => 'DAB_ArticleMS',
  'http://www.articlekit.com' => 'DAB_ArticleMS',
  'http://articlecontenthub.com' => 'DAB_ArticleMS',
  'http://www.liferyte.com/LR' => 'DAB_ArticleMS',
  'http://www.publishingdaily.com' => 'DAB_ArticleMS',
  'http://www.articleexpress.net/article' => 'DAB_ArticleMS',
  'http://www.howtoknowitall.com' => 'DAB_ArticleMS',
  'http://www.dognation.net/articles' => 'DAB_ArticleMS',
  'http://www.fiercepower.com/articles' => 'DAB_ArticleMS',
  'http://www.search-engine-optimization-submissions.com' => 'DAB_ArticleMS',
  'http://marketmysite.info' => 'DAB_ArticleMS',
  'http://www.articles.austinrealestateshopper.com' => 'DAB_ArticleMS',
  'http://chat24-7.com' => 'DAB_ArticleMS',
  'http://www.den-tex.com/ArticleDirectory' => 'DAB_ArticleMS',
  'http://brent.rangen.net/Articles' => 'DAB_ArticleMS',
  'http://www.studentdream.com/termpaper' => 'DAB_ArticleMS',
  'http://www.articlecloud.org' => 'DAB_ArticleMS',
  'http://articles.chennaibusiness.co.in' => 'DAB_ArticleMS',
  'http://www.ebusinesslog.com' => 'DAB_ArticleMS',
  'http://webarticles.putso.net' => 'DAB_ArticleMS',
  'http://www.improveskillsacademy.org' => 'DAB_ArticleMS',
  'http://www.magiwebs.com/articles' => 'DAB_ArticleMS',
  'http://classifiedsvolume.com' => 'DAB_ArticleMS',
  'http://www.article.finnol.com' => 'DAB_ArticleMS',
  'http://www.w3articles.org' => 'DAB_ArticleMS',
  'http://www.submitbusinessarticles.com' => 'DAB_ArticleMS',
  'http://lookinggoodlexington.webatu.com/articles/index.php' => 'DAB_ArticleMS',
  'http://mortgagetips411.com' => 'DAB_ArticleMS',
  'http://www.articleadvise.com/' => 'DAB_ArticleMS',
  'http://www.circledirectory.com' => 'DAB_ArticleMS',
  // 'http://www.deadvip.com' => 'DAB_ArticleMS', # printview doesn't work

  // 'http://1-bg.info' => 'DAB_ArticleSetup', # Cyrillic
  'http://anigoo.com/articles' => 'DAB_ArticleSetup',
  'http://articlecartridge.com' => 'DAB_ArticleSetup',
  'http://articles.bestaffilatemarketing.com' => 'DAB_ArticleSetup',
  'http://articles.cheapcameraworld.com' => 'DAB_ArticleSetup',
  'http://articles.cheapluxuriousfurniture.com' => 'DAB_ArticleSetup',
  'http://articles.cheeprentahouse.com' => 'DAB_ArticleSetup',
  'http://articles.onlinelifeinsuranceagents.com' => 'DAB_ArticleSetup',
  'http://articles.quoteswave.com' => 'DAB_ArticleSetup',
  'http://articles.resultofadvancetechnology.com' => 'DAB_ArticleSetup',
  'http://bestarticles123.com' => 'DAB_ArticleSetup',
  'http://bg-traveller.com' => 'DAB_ArticleSetup',
  'http://bwithyou.com/article' => 'DAB_ArticleSetup',
  'http://constructionbannerexchange.com/article' => 'DAB_ArticleSetup',
  'http://everythingabouthorses.com' => 'DAB_ArticleSetup',
  'http://googlelinks.net' => 'DAB_ArticleSetup',
  'http://hi4.in' => 'DAB_ArticleSetup',
  'http://letcash.com' => 'DAB_ArticleSetup',
  'http://media.coloradopatientcoalition.com' => 'DAB_ArticleSetup',
  'http://msn4free.com' => 'DAB_ArticleSetup',
  'http://orbitarticles.com' => 'DAB_ArticleSetup',
  'http://personalcontact.org' => 'DAB_ArticleSetup',
  'http://productsforall.com' => 'DAB_ArticleSetup',
  'http://revenuestratergy.com' => 'DAB_ArticleSetup',
  // 'http://sahitkar.com' => 'DAB_ArticleSetup', # Sanskrit
  'http://snapoint.org/content' => 'DAB_ArticleSetup',
  'http://thearticlelist.com' => 'DAB_ArticleSetup',
  'http://topeco.co.uk/articles' => 'DAB_ArticleSetup',
  'http://uniquearticle.org' => 'DAB_ArticleSetup',
  'http://www.1-bg.info' => 'DAB_ArticleSetup',
  'http://www.1magzine.com' => 'DAB_ArticleSetup',
  'http://www.allaboutarticle.com' => 'DAB_ArticleSetup',
  'http://www.articlepiece.com' => 'DAB_ArticleSetup',
  'http://www.articles-on-health.net' => 'DAB_ArticleSetup',
  'http://www.articlesindex.net' => 'DAB_ArticleSetup',
  'http://www.articlesprey.com' => 'DAB_ArticleSetup',
  'http://www.articlesrocket.com' => 'DAB_ArticleSetup',
  'http://www.bg-traveller.com' => 'DAB_ArticleSetup',
  // 'http://www.christarena.com' => 'DAB_ArticleSetup', # Not appropriate
  'http://www.e-articles.org' => 'DAB_ArticleSetup',
  'http://www.edarticle.com' => 'DAB_ArticleSetup',
  'http://www.elitewebsports.com' => 'DAB_ArticleSetup',
  'http://www.everythingabouthorses.com' => 'DAB_ArticleSetup',
  'http://www.ezineplace.com' => 'DAB_ArticleSetup',
  'http://www.findarticles.eu' => 'DAB_ArticleSetup',
  'http://www.googlelinks.net' => 'DAB_ArticleSetup',
  'http://www.hiworldarticles.com' => 'DAB_ArticleSetup',
  'http://www.imarticledirectory.com' => 'DAB_ArticleSetup',
  'http://www.internethighways.com' => 'DAB_ArticleSetup',
  'http://www.itkatalogen.se' => 'DAB_ArticleSetup',
  'http://www.manuelaranda.cl' => 'DAB_ArticleSetup',
  'http://www.omg.6f.sk/aktuality' => 'DAB_ArticleSetup',
  'http://www.productsforall.com' => 'DAB_ArticleSetup',
  'http://www.purearticle.com' => 'DAB_ArticleSetup',
  'http://www.qnaguides.com' => 'DAB_ArticleSetup',
  'http://www.rickblog.net' => 'DAB_ArticleSetup',
  'http://www.seymourab.com/articlesetup/upload' => 'DAB_ArticleSetup',
  'http://www.thearticlevault.co.uk' => 'DAB_ArticleSetup',
  'http://www.thearticlez.info' => 'DAB_ArticleSetup',
  'http://www.thechickenforum.info/chickipedia' => 'DAB_ArticleSetup',
  'http://www.ticaretturizm.com' => 'DAB_ArticleSetup',
  'http://www.tobealawyer.net' => 'DAB_ArticleSetup',
  'http://www.topeco.co.uk/articles' => 'DAB_ArticleSetup',
  'http://www.totuusseerumi.com' => 'DAB_ArticleSetup',
  'http://www.inmarketing.org' => 'DAB_ArticleSetup',
  'http://articles.loseyourfate.com' => 'DAB_ArticleSetup',
  'http://orbitarticles.com' => 'DAB_ArticleSetup',
  'http://anigoo.com/articles' => 'DAB_ArticleSetup',
  'http://www.telecallweb.com' => 'DAB_ArticleSetup',
  'http://www.as-articledirectory.info' => 'DAB_ArticleSetup',
  'http://fanarticle.com' => 'DAB_ArticleSetup',
  'http://articles.n3ws.org' => 'DAB_ArticleSetup',
  'http://articlehub.easyera.com' => 'DAB_ArticleSetup',
  'http://articles.tvshowstonight.com' => 'DAB_ArticleSetup',
  'http://articles.secureonlinebusinessworld.com' => 'DAB_ArticleSetup',
  'http://articles.cheapautoinsuranceservices.com' => 'DAB_ArticleSetup',
  'http://articles.besteffectoftechnology.com' => 'DAB_ArticleSetup',
  'http://articles.cheapsoftwarez.com' => 'DAB_ArticleSetup',
  'http://articles.homeinsuranceinfoservices.com' => 'DAB_ArticleSetup',
  'http://articles.businessinformationandadvice.com' => 'DAB_ArticleSetup',
  'http://articles.cheapinsuranceservicestips.com' => 'DAB_ArticleSetup',
  'http://ibizarticles.com' => 'DAB_ArticleSetup',
  'http://euroson.me/articles' => 'DAB_ArticleSetup',
  'http://articles.searchcheaphouse.com' => 'DAB_ArticleSetup',
  'http://articles.bestlinkbuildingpackages.com' => 'DAB_ArticleSetup',
  'http://submitarticle.me' => 'DAB_ArticleSetup',
  'http://www.thenewcomers.co/article' => 'DAB_ArticleSetup',
  'http://www.article-exchange.co.cc' => 'DAB_ArticleSetup',
  'http://articles.squarehealthtips.com' => 'DAB_ArticleSetup',
  'http://articles.onlinedatingchain.com' => 'DAB_ArticleSetup',
  'http://www.meoaryans.com/articles/upload' => 'DAB_ArticleSetup',
  'http://www.adscb.com/articles' => 'DAB_ArticleSetup',
  'http://www.usubmitarticles.com' => 'DAB_ArticleSetup',
  'http://www.moneymattersonline.co.uk' => 'DAB_ArticleSetup',
  'http://www.siarticles.co.cc' => 'DAB_ArticleSetup',
  'http://whatandhow.co.in' => 'DAB_ArticleSetup',
  'http://articleskip.com' => 'DAB_ArticleSetup',
  'http://darkanime.org' => 'DAB_ArticleSetup',
  'http://www.aprilium.com' => 'DAB_ArticleSetup',
  'http://articles.earnmoneyfromweb.com' => 'DAB_ArticleSetup',
  'http://articles.onlinepersonalinsurance.com' => 'DAB_ArticleSetup',
  'http://articles.onlinecarinsuranceservices.com' => 'DAB_ArticleSetup',
  'http://articles.moneymakingtipsandguides.com' => 'DAB_ArticleSetup',
  'http://www.articles-ad.com' => 'DAB_ArticleSetup',
  'http://articles.businessinformationandadvice.com' => 'DAB_ArticleSetup',
  'http://articles.bestseoandsemcompany.com' => 'DAB_ArticleSetup',
  'http://www.hi4.in' => 'DAB_ArticleSetup',
  'http://articles.buydomainsretail.com' => 'DAB_ArticleSetup',
  'http://www.articleshrine.com' => 'DAB_ArticleSetup',
  'http://article.williamrenfro.com' => 'DAB_ArticleSetup',
  'http://balkanface.com' => 'DAB_ArticleSetup',
  'http://www.newagesearch.com' => 'DAB_ArticleSetup',
  'http://www.article.coolguruji.com' => 'DAB_ArticleSetup',
  'http://www.neakkhmer.com' => 'DAB_ArticleSetup',
  'http://free-article-directory.decksharks-records.com' => 'DAB_ArticleSetup',
  'http://www.todaysarticlewriter.com' => 'DAB_ArticleSetup',
  'http://www.specialarticles.com' => 'DAB_ArticleSetup',
  'http://www.a2zarticlesdirectory.com' => 'DAB_ArticleSetup',
  'http://article-about.co.uk' => 'DAB_ArticleSetup',
  'http://www.thearticlesdirectory.co.uk/' => 'DAB_ArticleSetup',
  'http://www.dasarticles.com' => 'DAB_ArticleSetup',
);

$dab_need_confirm_sites = array(
  'http://americanlegaljournal.com' => 'DAB_ArticleMS',
  'http://articlebazar.net' => 'DAB_ArticleMS',
  'http://dafind.com' => 'DAB_ArticleMS',
  'http://dmiq.com' => 'DAB_ArticleMS',
  'http://ezine-articles-planet.com' => 'DAB_ArticleMS',
  'http://isysi.com' => 'DAB_ArticleMS',
  'http://nippomac.info' => 'DAB_ArticleMS',
  'http://texdigi.com' => 'DAB_ArticleMS',
  'http://www.allbestarticles.com' => 'DAB_ArticleMS',
  'http://www.article-directory.us' => 'DAB_ArticleMS',
  'http://www.articlegods.com' => 'DAB_ArticleMS',
  'http://www.articleparots.com' => 'DAB_ArticleMS',
  'http://www.articlesbusiness.net' => 'DAB_ArticleMS', // Lol SQL injection?
  'http://www.articlesnets.com' => 'DAB_ArticleMS',
  'http://www.everydayarticles.com' => 'DAB_ArticleMS',
  'http://www.featuredarticles.co.uk' => 'DAB_ArticleMS',
  'http://www.grelohi.com' => 'DAB_ArticleMS',
  'http://www.lawakjenaka.com' => 'DAB_ArticleMS',
  'http://www.marketingsource.com/articles' => 'DAB_ArticleMS',
  'http://www.mixinglivesound.com/sound_articles' => 'DAB_ArticleMS',
  'http://www.myfreearticledirectory.com' => 'DAB_ArticleMS',
  'http://www.nichearticle.com' => 'DAB_ArticleMS',
  'http://www.prsurvival.com' => 'DAB_ArticleMS',
  'http://www.submithealtharticles.com' => 'DAB_ArticleMS',
  'http://www.i111s.com/articles' => 'DAB_ArticleMS',
  'http://www.webarticlefree.com' => 'DAB_ArticleMS',
  'http://www.articlecontentdirectory.com' => 'DAB_ArticleMS',
  'http://ibuiltmycomputer.com/computer_articles' => 'DAB_ArticleMS',
  'http://www.gocurrencytrading.com' => 'DAB_ArticleMS',
  'http://articles.itpimp.net' => 'DAB_ArticleMS',
  'http://www.behisbeautyqueen.com' => 'DAB_ArticleMS',
  'http://www.convenientarticles.com' => 'DAB_ArticleMS',
  'http://www.gethim2propose.com' => 'DAB_ArticleMS',
  'http://www.animalloverworld.com' => 'DAB_ArticleMS',
  'http://www.generalarticledirectories.com' => 'DAB_ArticleMS',
  'http://www.gethimonhisknees.com' => 'DAB_ArticleMS',
  'http://www.mycrysta.com' => 'DAB_ArticleMS',
  'http://www.freearticlesmarketing.com' => 'DAB_ArticleMS',
  'http://justezine.com' => 'DAB_ArticleMS', # Slow server
  'http://articopia.com' => 'DAB_ArticleMS',
  'http://www.contextrace.com/articles' => 'DAB_ArticleMS',
  'http://www.internationalbrands.co.in' => 'DAB_ArticleMS',
  'http://artikelmagazin.info' => 'DAB_ArticleMS',
);


// The categories we let the user choose from. Taken from default install of
// ArticleMS
function dab_possible_categories() {
  return array(
    'Arts and Entertainment' => 'Arts and Entertainment',
    'Arts and Entertainment -- Arts and Entertainment' => '&nbsp;&nbsp;&nbsp;&nbsp;Arts and Entertainment',
    'Arts and Entertainment -- Astrology' => '&nbsp;&nbsp;&nbsp;&nbsp;Astrology',
    'Arts and Entertainment -- Casino Gambling' => '&nbsp;&nbsp;&nbsp;&nbsp;Casino Gambling',
    'Arts and Entertainment -- Humanities' => '&nbsp;&nbsp;&nbsp;&nbsp;Humanities',
    'Arts and Entertainment -- Humor' => '&nbsp;&nbsp;&nbsp;&nbsp;Humor',
    'Arts and Entertainment -- Language' => '&nbsp;&nbsp;&nbsp;&nbsp;Language',
    'Arts and Entertainment -- Movies TV' => '&nbsp;&nbsp;&nbsp;&nbsp;Movies TV',
    'Arts and Entertainment -- Music' => '&nbsp;&nbsp;&nbsp;&nbsp;Music',
    'Arts and Entertainment -- Philosophy' => '&nbsp;&nbsp;&nbsp;&nbsp;Philosophy',
    'Arts and Entertainment -- Photography' => '&nbsp;&nbsp;&nbsp;&nbsp;Photography',
    'Arts and Entertainment -- Poetry' => '&nbsp;&nbsp;&nbsp;&nbsp;Poetry',
    'Arts and Entertainment -- Tattoos' => '&nbsp;&nbsp;&nbsp;&nbsp;Tattoos',
    'Automotive' => 'Automotive',
    'Automotive -- ATV' => '&nbsp;&nbsp;&nbsp;&nbsp;ATV',
    'Automotive -- Automotive' => '&nbsp;&nbsp;&nbsp;&nbsp;Automotive',
    'Automotive -- Cars' => '&nbsp;&nbsp;&nbsp;&nbsp;Cars',
    'Automotive -- Maintenance' => '&nbsp;&nbsp;&nbsp;&nbsp;Maintenance',
    'Automotive -- Mobile Audio Video' => '&nbsp;&nbsp;&nbsp;&nbsp;Mobile Audio Video',
    'Automotive -- Motorcycles' => '&nbsp;&nbsp;&nbsp;&nbsp;Motorcycles',
    'Automotive -- RV' => '&nbsp;&nbsp;&nbsp;&nbsp;RV',
    'Automotive -- Trucks' => '&nbsp;&nbsp;&nbsp;&nbsp;Trucks',
    'Business' => 'Business',
    'Business -- Accounting' => '&nbsp;&nbsp;&nbsp;&nbsp;Accounting',
    'Business -- Accounting Payroll' => '&nbsp;&nbsp;&nbsp;&nbsp;Accounting Payroll',
    'Business -- Advertising' => '&nbsp;&nbsp;&nbsp;&nbsp;Advertising',
    'Business -- Branding' => '&nbsp;&nbsp;&nbsp;&nbsp;Branding',
    'Business -- Business' => '&nbsp;&nbsp;&nbsp;&nbsp;Business',
    'Business -- Career' => '&nbsp;&nbsp;&nbsp;&nbsp;Career',
    'Business -- Careers Employment' => '&nbsp;&nbsp;&nbsp;&nbsp;Careers Employment',
    'Business -- Change Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Change Management',
    'Business -- Customer Service' => '&nbsp;&nbsp;&nbsp;&nbsp;Customer Service',
    'Business -- Entrepreneurialism' => '&nbsp;&nbsp;&nbsp;&nbsp;Entrepreneurialism',
    'Business -- Ethics' => '&nbsp;&nbsp;&nbsp;&nbsp;Ethics',
    'Business -- Franchising' => '&nbsp;&nbsp;&nbsp;&nbsp;Franchising',
    'Business -- Fundraising' => '&nbsp;&nbsp;&nbsp;&nbsp;Fundraising',
    'Business -- Industrial Mechanical' => '&nbsp;&nbsp;&nbsp;&nbsp;Industrial Mechanical',
    'Business -- Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Management',
    'Business -- Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Marketing',
    'Business -- Marketing Direct' => '&nbsp;&nbsp;&nbsp;&nbsp;Marketing Direct',
    'Business -- Negotiation' => '&nbsp;&nbsp;&nbsp;&nbsp;Negotiation',
    'Business -- Networking' => '&nbsp;&nbsp;&nbsp;&nbsp;Networking',
    'Business -- Office Communication' => '&nbsp;&nbsp;&nbsp;&nbsp;Office Communication',
    'Business -- Outsourcing' => '&nbsp;&nbsp;&nbsp;&nbsp;Outsourcing',
    'Business -- PR' => '&nbsp;&nbsp;&nbsp;&nbsp;PR',
    'Business -- Presentation' => '&nbsp;&nbsp;&nbsp;&nbsp;Presentation',
    'Business -- Productivity' => '&nbsp;&nbsp;&nbsp;&nbsp;Productivity',
    'Business -- Resumes Cover Letters' => '&nbsp;&nbsp;&nbsp;&nbsp;Resumes Cover Letters',
    'Business -- Sales' => '&nbsp;&nbsp;&nbsp;&nbsp;Sales',
    'Business -- Sales Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Sales Management',
    'Business -- Sales Teleselling' => '&nbsp;&nbsp;&nbsp;&nbsp;Sales Teleselling',
    'Business -- Sales Training' => '&nbsp;&nbsp;&nbsp;&nbsp;Sales Training',
    'Business -- Small Business' => '&nbsp;&nbsp;&nbsp;&nbsp;Small Business',
    'Business -- Solo Professionals' => '&nbsp;&nbsp;&nbsp;&nbsp;Solo Professionals',
    'Business -- Strategic Planning' => '&nbsp;&nbsp;&nbsp;&nbsp;Strategic Planning',
    'Business -- Team Building' => '&nbsp;&nbsp;&nbsp;&nbsp;Team Building',
    'Business -- Top7 or 10 Tips' => '&nbsp;&nbsp;&nbsp;&nbsp;Top7 or 10 Tips',
    'Business -- Venture Capital' => '&nbsp;&nbsp;&nbsp;&nbsp;Venture Capital',
    'Cancer' => 'Cancer',
    'Cancer -- Breast Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Breast Cancer',
    'Cancer -- Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Cancer',
    'Cancer -- Colon Rectal Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Colon Rectal Cancer',
    'Cancer -- Leukemia Lymphoma' => '&nbsp;&nbsp;&nbsp;&nbsp;Leukemia Lymphoma',
    'Cancer -- Mesothelioma Asbestos' => '&nbsp;&nbsp;&nbsp;&nbsp;Mesothelioma Asbestos',
    'Cancer -- Ovarian Cervical Uterine' => '&nbsp;&nbsp;&nbsp;&nbsp;Ovarian Cervical Uterine',
    'Cancer -- Prostate Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Prostate Cancer',
    'Cancer -- Skin Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Skin Cancer',
    'Communications' => 'Communications',
    'Communications -- Broadband Internet' => '&nbsp;&nbsp;&nbsp;&nbsp;Broadband Internet',
    'Communications -- Communications' => '&nbsp;&nbsp;&nbsp;&nbsp;Communications',
    'Communications -- Fax' => '&nbsp;&nbsp;&nbsp;&nbsp;Fax',
    'Communications -- GPS' => '&nbsp;&nbsp;&nbsp;&nbsp;GPS',
    'Communications -- Mobile Cell Phone' => '&nbsp;&nbsp;&nbsp;&nbsp;Mobile Cell Phone',
    'Communications -- Satellite Radio' => '&nbsp;&nbsp;&nbsp;&nbsp;Satellite Radio',
    'Communications -- Satellite TV' => '&nbsp;&nbsp;&nbsp;&nbsp;Satellite TV',
    'Communications -- Telephone Systems' => '&nbsp;&nbsp;&nbsp;&nbsp;Telephone Systems',
    'Communications -- Video Conferencing' => '&nbsp;&nbsp;&nbsp;&nbsp;Video Conferencing',
    'Communications -- VOIP' => '&nbsp;&nbsp;&nbsp;&nbsp;VOIP',
    'Computers and Technology' => 'Computers and Technology',
    'Computers and Technology -- Certification Tests' => '&nbsp;&nbsp;&nbsp;&nbsp;Certification Tests',
    'Computers and Technology -- Computers, Technology' => '&nbsp;&nbsp;&nbsp;&nbsp;Computers, Technology',
    'Computers and Technology -- Data Recovery' => '&nbsp;&nbsp;&nbsp;&nbsp;Data Recovery',
    'Computers and Technology -- Games' => '&nbsp;&nbsp;&nbsp;&nbsp;Games',
    'Computers and Technology -- Hardware' => '&nbsp;&nbsp;&nbsp;&nbsp;Hardware',
    'Computers and Technology -- Mobile Computing' => '&nbsp;&nbsp;&nbsp;&nbsp;Mobile Computing',
    'Computers and Technology -- Personal Tech' => '&nbsp;&nbsp;&nbsp;&nbsp;Personal Tech',
    'Computers and Technology -- Software' => '&nbsp;&nbsp;&nbsp;&nbsp;Software',
    'Finance' => 'Finance',
    'Finance -- Bankruptcy' => '&nbsp;&nbsp;&nbsp;&nbsp;Bankruptcy',
    'Finance -- Credit' => '&nbsp;&nbsp;&nbsp;&nbsp;Credit',
    'Finance -- Currency Trading' => '&nbsp;&nbsp;&nbsp;&nbsp;Currency Trading',
    'Finance -- Debt' => '&nbsp;&nbsp;&nbsp;&nbsp;Debt',
    'Finance -- Debt Consolidation' => '&nbsp;&nbsp;&nbsp;&nbsp;Debt Consolidation',
    'Finance -- Debt Relief' => '&nbsp;&nbsp;&nbsp;&nbsp;Debt Relief',
    'Finance -- Estate Plan Trusts' => '&nbsp;&nbsp;&nbsp;&nbsp;Estate Plan Trusts',
    'Finance -- Finance' => '&nbsp;&nbsp;&nbsp;&nbsp;Finance',
    'Finance -- Insurance' => '&nbsp;&nbsp;&nbsp;&nbsp;Insurance',
    'Finance -- Investing' => '&nbsp;&nbsp;&nbsp;&nbsp;Investing',
    'Finance -- Leases Leasing' => '&nbsp;&nbsp;&nbsp;&nbsp;Leases Leasing',
    'Finance -- Loans' => '&nbsp;&nbsp;&nbsp;&nbsp;Loans',
    'Finance -- Mortgage' => '&nbsp;&nbsp;&nbsp;&nbsp;Mortgage',
    'Finance -- Personal Finance' => '&nbsp;&nbsp;&nbsp;&nbsp;Personal Finance',
    'Finance -- Real Estate' => '&nbsp;&nbsp;&nbsp;&nbsp;Real Estate',
    'Finance -- Stocks Mutual Funds' => '&nbsp;&nbsp;&nbsp;&nbsp;Stocks Mutual Funds',
    'Finance -- Structured Settlements' => '&nbsp;&nbsp;&nbsp;&nbsp;Structured Settlements',
    'Finance -- Taxes' => '&nbsp;&nbsp;&nbsp;&nbsp;Taxes',
    'Finance -- Wealth Building' => '&nbsp;&nbsp;&nbsp;&nbsp;Wealth Building',
    'Food and Drink' => 'Food and Drink',
    'Food and Drink -- Chocolate' => '&nbsp;&nbsp;&nbsp;&nbsp;Chocolate',
    'Food and Drink -- Coffee' => '&nbsp;&nbsp;&nbsp;&nbsp;Coffee',
    'Food and Drink -- Cooking' => '&nbsp;&nbsp;&nbsp;&nbsp;Cooking',
    'Food and Drink -- Cooking Tips' => '&nbsp;&nbsp;&nbsp;&nbsp;Cooking Tips',
    'Food and Drink -- Crockpot Recipes' => '&nbsp;&nbsp;&nbsp;&nbsp;Crockpot Recipes',
    'Food and Drink -- Desserts' => '&nbsp;&nbsp;&nbsp;&nbsp;Desserts',
    'Food and Drink -- Food and Drink' => '&nbsp;&nbsp;&nbsp;&nbsp;Food and Drink',
    'Food and Drink -- Kids and Teens' => '&nbsp;&nbsp;&nbsp;&nbsp;Kids and Teens',
    'Food and Drink -- Low Calorie' => '&nbsp;&nbsp;&nbsp;&nbsp;Low Calorie',
    'Food and Drink -- Main Course' => '&nbsp;&nbsp;&nbsp;&nbsp;Main Course',
    'Food and Drink -- Pasta Dishes' => '&nbsp;&nbsp;&nbsp;&nbsp;Pasta Dishes',
    'Food and Drink -- Recipes' => '&nbsp;&nbsp;&nbsp;&nbsp;Recipes',
    'Food and Drink -- Restaurant Reviews' => '&nbsp;&nbsp;&nbsp;&nbsp;Restaurant Reviews',
    'Food and Drink -- Salads' => '&nbsp;&nbsp;&nbsp;&nbsp;Salads',
    'Food and Drink -- Soups' => '&nbsp;&nbsp;&nbsp;&nbsp;Soups',
    'Food and Drink -- Tea' => '&nbsp;&nbsp;&nbsp;&nbsp;Tea',
    'Food and Drink -- Wine Spirits' => '&nbsp;&nbsp;&nbsp;&nbsp;Wine Spirits',
    'Food and Drink -- Women\'s Interests' => '&nbsp;&nbsp;&nbsp;&nbsp;Women\'s Interests',
    'Health and Fitness' => 'Health and Fitness',
    'Health and Fitness -- Acne' => '&nbsp;&nbsp;&nbsp;&nbsp;Acne',
    'Health and Fitness -- Aerobics Cardio' => '&nbsp;&nbsp;&nbsp;&nbsp;Aerobics Cardio',
    'Health and Fitness -- Allergies' => '&nbsp;&nbsp;&nbsp;&nbsp;Allergies',
    'Health and Fitness -- Alternative' => '&nbsp;&nbsp;&nbsp;&nbsp;Alternative',
    'Health and Fitness -- Anti Aging' => '&nbsp;&nbsp;&nbsp;&nbsp;Anti Aging',
    'Health and Fitness -- Arthritis' => '&nbsp;&nbsp;&nbsp;&nbsp;Arthritis',
    'Health and Fitness -- Back Pain' => '&nbsp;&nbsp;&nbsp;&nbsp;Back Pain',
    'Health and Fitness -- Beauty' => '&nbsp;&nbsp;&nbsp;&nbsp;Beauty',
    'Health and Fitness -- Build Muscle' => '&nbsp;&nbsp;&nbsp;&nbsp;Build Muscle',
    'Health and Fitness -- Cancer' => '&nbsp;&nbsp;&nbsp;&nbsp;Cancer',
    'Health and Fitness -- Dental Care' => '&nbsp;&nbsp;&nbsp;&nbsp;Dental Care',
    'Health and Fitness -- Depression' => '&nbsp;&nbsp;&nbsp;&nbsp;Depression',
    'Health and Fitness -- Diabetes' => '&nbsp;&nbsp;&nbsp;&nbsp;Diabetes',
    'Health and Fitness -- Diseases' => '&nbsp;&nbsp;&nbsp;&nbsp;Diseases',
    'Health and Fitness -- Drug Abuse' => '&nbsp;&nbsp;&nbsp;&nbsp;Drug Abuse',
    'Health and Fitness -- Ears Hearing' => '&nbsp;&nbsp;&nbsp;&nbsp;Ears Hearing',
    'Health and Fitness -- Eating Disorders' => '&nbsp;&nbsp;&nbsp;&nbsp;Eating Disorders',
    'Health and Fitness -- Ergonomics' => '&nbsp;&nbsp;&nbsp;&nbsp;Ergonomics',
    'Health and Fitness -- Exercise' => '&nbsp;&nbsp;&nbsp;&nbsp;Exercise',
    'Health and Fitness -- Eyes Vision' => '&nbsp;&nbsp;&nbsp;&nbsp;Eyes Vision',
    'Health and Fitness -- Fitness' => '&nbsp;&nbsp;&nbsp;&nbsp;Fitness',
    'Health and Fitness -- Fitness Equipment' => '&nbsp;&nbsp;&nbsp;&nbsp;Fitness Equipment',
    'Health and Fitness -- Hair Loss' => '&nbsp;&nbsp;&nbsp;&nbsp;Hair Loss',
    'Health and Fitness -- Health and Fitness' => '&nbsp;&nbsp;&nbsp;&nbsp;Health and Fitness',
    'Health and Fitness -- Heart Disease' => '&nbsp;&nbsp;&nbsp;&nbsp;Heart Disease',
    'Health and Fitness -- Home Health Care' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Health Care',
    'Health and Fitness -- Lifestyle' => '&nbsp;&nbsp;&nbsp;&nbsp;Lifestyle',
    'Health and Fitness -- Massage' => '&nbsp;&nbsp;&nbsp;&nbsp;Massage',
    'Health and Fitness -- Medicine' => '&nbsp;&nbsp;&nbsp;&nbsp;Medicine',
    'Health and Fitness -- Meditation' => '&nbsp;&nbsp;&nbsp;&nbsp;Meditation',
    'Health and Fitness -- Men\'s Issues' => '&nbsp;&nbsp;&nbsp;&nbsp;Men\'s Issues',
    'Health and Fitness -- Mental Health' => '&nbsp;&nbsp;&nbsp;&nbsp;Mental Health',
    'Health and Fitness -- Nutrition' => '&nbsp;&nbsp;&nbsp;&nbsp;Nutrition',
    'Health and Fitness -- Obesity' => '&nbsp;&nbsp;&nbsp;&nbsp;Obesity',
    'Health and Fitness -- Pain Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Pain Management',
    'Health and Fitness -- Physical Therapy' => '&nbsp;&nbsp;&nbsp;&nbsp;Physical Therapy',
    'Health and Fitness -- Popular Diets' => '&nbsp;&nbsp;&nbsp;&nbsp;Popular Diets',
    'Health and Fitness -- Quit Smoking' => '&nbsp;&nbsp;&nbsp;&nbsp;Quit Smoking',
    'Health and Fitness -- Skin Care' => '&nbsp;&nbsp;&nbsp;&nbsp;Skin Care',
    'Health and Fitness -- Sleep Snoring' => '&nbsp;&nbsp;&nbsp;&nbsp;Sleep Snoring',
    'Health and Fitness -- Stress' => '&nbsp;&nbsp;&nbsp;&nbsp;Stress',
    'Health and Fitness -- Supplements' => '&nbsp;&nbsp;&nbsp;&nbsp;Supplements',
    'Health and Fitness -- Weight Loss' => '&nbsp;&nbsp;&nbsp;&nbsp;Weight Loss',
    'Health and Fitness -- Women\'s Issues' => '&nbsp;&nbsp;&nbsp;&nbsp;Women\'s Issues',
    'Health and Fitness -- Yoga' => '&nbsp;&nbsp;&nbsp;&nbsp;Yoga',
    'Home and Family' => 'Home and Family',
    'Home and Family -- Babies Toddler' => '&nbsp;&nbsp;&nbsp;&nbsp;Babies Toddler',
    'Home and Family -- Baby Boomer' => '&nbsp;&nbsp;&nbsp;&nbsp;Baby Boomer',
    'Home and Family -- Crafts Hobbies' => '&nbsp;&nbsp;&nbsp;&nbsp;Crafts Hobbies',
    'Home and Family -- Elder Care' => '&nbsp;&nbsp;&nbsp;&nbsp;Elder Care',
    'Home and Family -- Gardening' => '&nbsp;&nbsp;&nbsp;&nbsp;Gardening',
    'Home and Family -- Hobbies' => '&nbsp;&nbsp;&nbsp;&nbsp;Hobbies',
    'Home and Family -- Holidays' => '&nbsp;&nbsp;&nbsp;&nbsp;Holidays',
    'Home and Family -- Home and Family' => '&nbsp;&nbsp;&nbsp;&nbsp;Home and Family',
    'Home and Family -- Home Improvement' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Improvement',
    'Home and Family -- Home Security' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Security',
    'Home and Family -- Interior Design' => '&nbsp;&nbsp;&nbsp;&nbsp;Interior Design',
    'Home and Family -- Kids' => '&nbsp;&nbsp;&nbsp;&nbsp;Kids',
    'Home and Family -- Parenting' => '&nbsp;&nbsp;&nbsp;&nbsp;Parenting',
    'Home and Family -- Parties' => '&nbsp;&nbsp;&nbsp;&nbsp;Parties',
    'Home and Family -- Pets' => '&nbsp;&nbsp;&nbsp;&nbsp;Pets',
    'Home and Family -- Pregnancy' => '&nbsp;&nbsp;&nbsp;&nbsp;Pregnancy',
    'Home and Family -- Retirement' => '&nbsp;&nbsp;&nbsp;&nbsp;Retirement',
    'Home and Family -- Scrapbooking' => '&nbsp;&nbsp;&nbsp;&nbsp;Scrapbooking',
    'Home Based Business' => 'Home Based Business',
    'Home Based Business -- Home Based Business' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Based Business',
    'Home Based Business -- Network Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Network Marketing',
    'Home Improvement' => 'Home Improvement',
    'Home Improvement -- Appliances' => '&nbsp;&nbsp;&nbsp;&nbsp;Appliances',
    'Home Improvement -- Audio Video' => '&nbsp;&nbsp;&nbsp;&nbsp;Audio Video',
    'Home Improvement -- Bath and Shower' => '&nbsp;&nbsp;&nbsp;&nbsp;Bath and Shower',
    'Home Improvement -- Cabinets' => '&nbsp;&nbsp;&nbsp;&nbsp;Cabinets',
    'Home Improvement -- Cleaning Tips and Tools' => '&nbsp;&nbsp;&nbsp;&nbsp;Cleaning Tips and Tools',
    'Home Improvement -- Concrete' => '&nbsp;&nbsp;&nbsp;&nbsp;Concrete',
    'Home Improvement -- DIY' => '&nbsp;&nbsp;&nbsp;&nbsp;DIY',
    'Home Improvement -- Doors' => '&nbsp;&nbsp;&nbsp;&nbsp;Doors',
    'Home Improvement -- Electrical' => '&nbsp;&nbsp;&nbsp;&nbsp;Electrical',
    'Home Improvement -- Flooring' => '&nbsp;&nbsp;&nbsp;&nbsp;Flooring',
    'Home Improvement -- Foundation' => '&nbsp;&nbsp;&nbsp;&nbsp;Foundation',
    'Home Improvement -- Furniture' => '&nbsp;&nbsp;&nbsp;&nbsp;Furniture',
    'Home Improvement -- Heating, Air Conditioning' => '&nbsp;&nbsp;&nbsp;&nbsp;Heating, Air Conditioning',
    'Home Improvement -- Home Improvement' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Improvement',
    'Home Improvement -- House Plans' => '&nbsp;&nbsp;&nbsp;&nbsp;House Plans',
    'Home Improvement -- Interior Design' => '&nbsp;&nbsp;&nbsp;&nbsp;Interior Design',
    'Home Improvement -- Kitchen Improvements' => '&nbsp;&nbsp;&nbsp;&nbsp;Kitchen Improvements',
    'Home Improvement -- Lighting' => '&nbsp;&nbsp;&nbsp;&nbsp;Lighting',
    'Home Improvement -- New Construction' => '&nbsp;&nbsp;&nbsp;&nbsp;New Construction',
    'Home Improvement -- Outdoor Decorating' => '&nbsp;&nbsp;&nbsp;&nbsp;Outdoor Decorating',
    'Home Improvement -- Painting' => '&nbsp;&nbsp;&nbsp;&nbsp;Painting',
    'Home Improvement -- Patio Deck' => '&nbsp;&nbsp;&nbsp;&nbsp;Patio Deck',
    'Home Improvement -- Plumbing' => '&nbsp;&nbsp;&nbsp;&nbsp;Plumbing',
    'Home Improvement -- Remodeling' => '&nbsp;&nbsp;&nbsp;&nbsp;Remodeling',
    'Home Improvement -- Roofing' => '&nbsp;&nbsp;&nbsp;&nbsp;Roofing',
    'Home Improvement -- Security' => '&nbsp;&nbsp;&nbsp;&nbsp;Security',
    'Home Improvement -- Stone Brick' => '&nbsp;&nbsp;&nbsp;&nbsp;Stone Brick',
    'Home Improvement -- Storage Garage' => '&nbsp;&nbsp;&nbsp;&nbsp;Storage Garage',
    'Home Improvement -- Tools and Equipment' => '&nbsp;&nbsp;&nbsp;&nbsp;Tools and Equipment',
    'Home Improvement -- Windows' => '&nbsp;&nbsp;&nbsp;&nbsp;Windows',
    'Insurance' => 'Insurance',
    'Insurance -- Agents Marketers' => '&nbsp;&nbsp;&nbsp;&nbsp;Agents Marketers',
    'Insurance -- Car Auto' => '&nbsp;&nbsp;&nbsp;&nbsp;Car Auto',
    'Insurance -- Commercial' => '&nbsp;&nbsp;&nbsp;&nbsp;Commercial',
    'Insurance -- Dental' => '&nbsp;&nbsp;&nbsp;&nbsp;Dental',
    'Insurance -- Disability' => '&nbsp;&nbsp;&nbsp;&nbsp;Disability',
    'Insurance -- Flood' => '&nbsp;&nbsp;&nbsp;&nbsp;Flood',
    'Insurance -- Health' => '&nbsp;&nbsp;&nbsp;&nbsp;Health',
    'Insurance -- Home Owners Renters' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Owners Renters',
    'Insurance -- Insurance' => '&nbsp;&nbsp;&nbsp;&nbsp;Insurance',
    'Insurance -- Life Annuities' => '&nbsp;&nbsp;&nbsp;&nbsp;Life Annuities',
    'Insurance -- Long Term Care' => '&nbsp;&nbsp;&nbsp;&nbsp;Long Term Care',
    'Insurance -- Personal Property' => '&nbsp;&nbsp;&nbsp;&nbsp;Personal Property',
    'Insurance -- Pet' => '&nbsp;&nbsp;&nbsp;&nbsp;Pet',
    'Insurance -- RV Motorcycle' => '&nbsp;&nbsp;&nbsp;&nbsp;RV Motorcycle',
    'Insurance -- Supplemental' => '&nbsp;&nbsp;&nbsp;&nbsp;Supplemental',
    'Insurance -- Travel' => '&nbsp;&nbsp;&nbsp;&nbsp;Travel',
    'Insurance -- Umbrella' => '&nbsp;&nbsp;&nbsp;&nbsp;Umbrella',
    'Insurance -- Vision' => '&nbsp;&nbsp;&nbsp;&nbsp;Vision',
    'Insurance -- Watercraft' => '&nbsp;&nbsp;&nbsp;&nbsp;Watercraft',
    'Insurance -- Workers Compensation' => '&nbsp;&nbsp;&nbsp;&nbsp;Workers Compensation',
    'Internet and Businesses Online' => 'Internet and Businesses Online',
    'Internet and Businesses Online -- Affiliate Programs' => '&nbsp;&nbsp;&nbsp;&nbsp;Affiliate Programs',
    'Internet and Businesses Online -- Affiliate Revenue' => '&nbsp;&nbsp;&nbsp;&nbsp;Affiliate Revenue',
    'Internet and Businesses Online -- Auctions' => '&nbsp;&nbsp;&nbsp;&nbsp;Auctions',
    'Internet and Businesses Online -- Audio Streaming' => '&nbsp;&nbsp;&nbsp;&nbsp;Audio Streaming',
    'Internet and Businesses Online -- Autoresponders' => '&nbsp;&nbsp;&nbsp;&nbsp;Autoresponders',
    'Internet and Businesses Online -- Banner Advertising' => '&nbsp;&nbsp;&nbsp;&nbsp;Banner Advertising',
    'Internet and Businesses Online -- Blogging' => '&nbsp;&nbsp;&nbsp;&nbsp;Blogging',
    'Internet and Businesses Online -- Domain Names' => '&nbsp;&nbsp;&nbsp;&nbsp;Domain Names',
    'Internet and Businesses Online -- E Books' => '&nbsp;&nbsp;&nbsp;&nbsp;E Books',
    'Internet and Businesses Online -- Ecommerce' => '&nbsp;&nbsp;&nbsp;&nbsp;Ecommerce',
    'Internet and Businesses Online -- Email' => '&nbsp;&nbsp;&nbsp;&nbsp;Email',
    'Internet and Businesses Online -- Email Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Email Marketing',
    'Internet and Businesses Online -- Ezine Publishing' => '&nbsp;&nbsp;&nbsp;&nbsp;Ezine Publishing',
    'Internet and Businesses Online -- Forums' => '&nbsp;&nbsp;&nbsp;&nbsp;Forums',
    'Internet and Businesses Online -- Internet Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Internet Marketing',
    'Internet and Businesses Online -- Internet, Online Business' => '&nbsp;&nbsp;&nbsp;&nbsp;Internet, Online Business',
    'Internet and Businesses Online -- Link Popularity' => '&nbsp;&nbsp;&nbsp;&nbsp;Link Popularity',
    'Internet and Businesses Online -- List Building' => '&nbsp;&nbsp;&nbsp;&nbsp;List Building',
    'Internet and Businesses Online -- Podcasting' => '&nbsp;&nbsp;&nbsp;&nbsp;Podcasting',
    'Internet and Businesses Online -- PPC Advertising' => '&nbsp;&nbsp;&nbsp;&nbsp;PPC Advertising',
    'Internet and Businesses Online -- PPC Publishing' => '&nbsp;&nbsp;&nbsp;&nbsp;PPC Publishing',
    'Internet and Businesses Online -- Product Creation' => '&nbsp;&nbsp;&nbsp;&nbsp;Product Creation',
    'Internet and Businesses Online -- Product Launching' => '&nbsp;&nbsp;&nbsp;&nbsp;Product Launching',
    'Internet and Businesses Online -- RSS' => '&nbsp;&nbsp;&nbsp;&nbsp;RSS',
    'Internet and Businesses Online -- Search Engine Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Search Engine Marketing',
    'Internet and Businesses Online -- Security' => '&nbsp;&nbsp;&nbsp;&nbsp;Security',
    'Internet and Businesses Online -- SEO' => '&nbsp;&nbsp;&nbsp;&nbsp;SEO',
    'Internet and Businesses Online -- Site Promotion' => '&nbsp;&nbsp;&nbsp;&nbsp;Site Promotion',
    'Internet and Businesses Online -- Social Bookmarking' => '&nbsp;&nbsp;&nbsp;&nbsp;Social Bookmarking',
    'Internet and Businesses Online -- Social Media' => '&nbsp;&nbsp;&nbsp;&nbsp;Social Media',
    'Internet and Businesses Online -- Social Networking' => '&nbsp;&nbsp;&nbsp;&nbsp;Social Networking',
    'Internet and Businesses Online -- Spam' => '&nbsp;&nbsp;&nbsp;&nbsp;Spam',
    'Internet and Businesses Online -- Spam Blocker' => '&nbsp;&nbsp;&nbsp;&nbsp;Spam Blocker',
    'Internet and Businesses Online -- Traffic Building' => '&nbsp;&nbsp;&nbsp;&nbsp;Traffic Building',
    'Internet and Businesses Online -- Video Streaming' => '&nbsp;&nbsp;&nbsp;&nbsp;Video Streaming',
    'Internet and Businesses Online -- Web Design' => '&nbsp;&nbsp;&nbsp;&nbsp;Web Design',
    'Internet and Businesses Online -- Web Development' => '&nbsp;&nbsp;&nbsp;&nbsp;Web Development',
    'Internet and Businesses Online -- Web Hosting' => '&nbsp;&nbsp;&nbsp;&nbsp;Web Hosting',
    'Legal' => 'Legal',
    'Legal -- Copyright' => '&nbsp;&nbsp;&nbsp;&nbsp;Copyright',
    'Legal -- Cyber Law' => '&nbsp;&nbsp;&nbsp;&nbsp;Cyber Law',
    'Legal -- Family Law' => '&nbsp;&nbsp;&nbsp;&nbsp;Family Law',
    'Legal -- Identity Theft' => '&nbsp;&nbsp;&nbsp;&nbsp;Identity Theft',
    'Legal -- Immigration' => '&nbsp;&nbsp;&nbsp;&nbsp;Immigration',
    'Legal -- Intellectual Property' => '&nbsp;&nbsp;&nbsp;&nbsp;Intellectual Property',
    'Legal -- Legal' => '&nbsp;&nbsp;&nbsp;&nbsp;Legal',
    'Legal -- Living Will' => '&nbsp;&nbsp;&nbsp;&nbsp;Living Will',
    'Legal -- Medical Malpractice' => '&nbsp;&nbsp;&nbsp;&nbsp;Medical Malpractice',
    'Legal -- National State Local' => '&nbsp;&nbsp;&nbsp;&nbsp;National State Local',
    'Legal -- Patents' => '&nbsp;&nbsp;&nbsp;&nbsp;Patents',
    'Legal -- Personal Injury' => '&nbsp;&nbsp;&nbsp;&nbsp;Personal Injury',
    'Legal -- Real Estate Law' => '&nbsp;&nbsp;&nbsp;&nbsp;Real Estate Law',
    'Legal -- Regulatory Compliance' => '&nbsp;&nbsp;&nbsp;&nbsp;Regulatory Compliance',
    'Legal -- Trademarks' => '&nbsp;&nbsp;&nbsp;&nbsp;Trademarks',
    'News and Society' => 'News and Society',
    'News and Society -- Crime' => '&nbsp;&nbsp;&nbsp;&nbsp;Crime',
    'News and Society -- Economics' => '&nbsp;&nbsp;&nbsp;&nbsp;Economics',
    'News and Society -- Energy' => '&nbsp;&nbsp;&nbsp;&nbsp;Energy',
    'News and Society -- Environmental' => '&nbsp;&nbsp;&nbsp;&nbsp;Environmental',
    'News and Society -- Military' => '&nbsp;&nbsp;&nbsp;&nbsp;Military',
    'News and Society -- News and Society' => '&nbsp;&nbsp;&nbsp;&nbsp;News and Society',
    'News and Society -- Politics' => '&nbsp;&nbsp;&nbsp;&nbsp;Politics',
    'News and Society -- Pure Opinion' => '&nbsp;&nbsp;&nbsp;&nbsp;Pure Opinion',
    'News and Society -- Religion' => '&nbsp;&nbsp;&nbsp;&nbsp;Religion',
    'News and Society -- Weather' => '&nbsp;&nbsp;&nbsp;&nbsp;Weather',
    'Pets' => 'Pets',
    'Pets -- Birds' => '&nbsp;&nbsp;&nbsp;&nbsp;Birds',
    'Pets -- Cats' => '&nbsp;&nbsp;&nbsp;&nbsp;Cats',
    'Pets -- Dogs' => '&nbsp;&nbsp;&nbsp;&nbsp;Dogs',
    'Pets -- Exotic' => '&nbsp;&nbsp;&nbsp;&nbsp;Exotic',
    'Pets -- Farm Ranch' => '&nbsp;&nbsp;&nbsp;&nbsp;Farm Ranch',
    'Pets -- Fish' => '&nbsp;&nbsp;&nbsp;&nbsp;Fish',
    'Pets -- Horses' => '&nbsp;&nbsp;&nbsp;&nbsp;Horses',
    'Pets -- Pets' => '&nbsp;&nbsp;&nbsp;&nbsp;Pets',
    'Pets -- Reptiles Amphibians' => '&nbsp;&nbsp;&nbsp;&nbsp;Reptiles Amphibians',
    'Real Estate' => 'Real Estate',
    'Real Estate -- Building a Home' => '&nbsp;&nbsp;&nbsp;&nbsp;Building a Home',
    'Real Estate -- Buying' => '&nbsp;&nbsp;&nbsp;&nbsp;Buying',
    'Real Estate -- Commercial Property' => '&nbsp;&nbsp;&nbsp;&nbsp;Commercial Property',
    'Real Estate -- Condominiums' => '&nbsp;&nbsp;&nbsp;&nbsp;Condominiums',
    'Real Estate -- Foreclosures' => '&nbsp;&nbsp;&nbsp;&nbsp;Foreclosures',
    'Real Estate -- FSBO' => '&nbsp;&nbsp;&nbsp;&nbsp;FSBO',
    'Real Estate -- Homes' => '&nbsp;&nbsp;&nbsp;&nbsp;Homes',
    'Real Estate -- Investing' => '&nbsp;&nbsp;&nbsp;&nbsp;Investing',
    'Real Estate -- Land' => '&nbsp;&nbsp;&nbsp;&nbsp;Land',
    'Real Estate -- Leasing Renting' => '&nbsp;&nbsp;&nbsp;&nbsp;Leasing Renting',
    'Real Estate -- Mortgage Refinance' => '&nbsp;&nbsp;&nbsp;&nbsp;Mortgage Refinance',
    'Real Estate -- Moving Relocating' => '&nbsp;&nbsp;&nbsp;&nbsp;Moving Relocating',
    'Real Estate -- Property Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Property Management',
    'Real Estate -- Real Estate' => '&nbsp;&nbsp;&nbsp;&nbsp;Real Estate',
    'Real Estate -- Selling' => '&nbsp;&nbsp;&nbsp;&nbsp;Selling',
    'Recreation and Sports' => 'Recreation and Sports',
    'Recreation and Sports -- Archery' => '&nbsp;&nbsp;&nbsp;&nbsp;Archery',
    'Recreation and Sports -- Auto Racing' => '&nbsp;&nbsp;&nbsp;&nbsp;Auto Racing',
    'Recreation and Sports -- Baseball' => '&nbsp;&nbsp;&nbsp;&nbsp;Baseball',
    'Recreation and Sports -- Basketball' => '&nbsp;&nbsp;&nbsp;&nbsp;Basketball',
    'Recreation and Sports -- Boating' => '&nbsp;&nbsp;&nbsp;&nbsp;Boating',
    'Recreation and Sports -- Bodybuilding' => '&nbsp;&nbsp;&nbsp;&nbsp;Bodybuilding',
    'Recreation and Sports -- Bowling' => '&nbsp;&nbsp;&nbsp;&nbsp;Bowling',
    'Recreation and Sports -- Boxing' => '&nbsp;&nbsp;&nbsp;&nbsp;Boxing',
    'Recreation and Sports -- Cheerleading' => '&nbsp;&nbsp;&nbsp;&nbsp;Cheerleading',
    'Recreation and Sports -- Climbing' => '&nbsp;&nbsp;&nbsp;&nbsp;Climbing',
    'Recreation and Sports -- Cricket' => '&nbsp;&nbsp;&nbsp;&nbsp;Cricket',
    'Recreation and Sports -- Cycling' => '&nbsp;&nbsp;&nbsp;&nbsp;Cycling',
    'Recreation and Sports -- Equestrian' => '&nbsp;&nbsp;&nbsp;&nbsp;Equestrian',
    'Recreation and Sports -- Extreme' => '&nbsp;&nbsp;&nbsp;&nbsp;Extreme',
    'Recreation and Sports -- Figure Skating' => '&nbsp;&nbsp;&nbsp;&nbsp;Figure Skating',
    'Recreation and Sports -- Fishing' => '&nbsp;&nbsp;&nbsp;&nbsp;Fishing',
    'Recreation and Sports -- Football' => '&nbsp;&nbsp;&nbsp;&nbsp;Football',
    'Recreation and Sports -- Golf' => '&nbsp;&nbsp;&nbsp;&nbsp;Golf',
    'Recreation and Sports -- Gymnastics' => '&nbsp;&nbsp;&nbsp;&nbsp;Gymnastics',
    'Recreation and Sports -- Hockey' => '&nbsp;&nbsp;&nbsp;&nbsp;Hockey',
    'Recreation and Sports -- Horse Racing' => '&nbsp;&nbsp;&nbsp;&nbsp;Horse Racing',
    'Recreation and Sports -- Hunting' => '&nbsp;&nbsp;&nbsp;&nbsp;Hunting',
    'Recreation and Sports -- Martial Arts' => '&nbsp;&nbsp;&nbsp;&nbsp;Martial Arts',
    'Recreation and Sports -- Mountain Biking' => '&nbsp;&nbsp;&nbsp;&nbsp;Mountain Biking',
    'Recreation and Sports -- Olympics' => '&nbsp;&nbsp;&nbsp;&nbsp;Olympics',
    'Recreation and Sports -- Racquetball' => '&nbsp;&nbsp;&nbsp;&nbsp;Racquetball',
    'Recreation and Sports -- Recreation and Sports' => '&nbsp;&nbsp;&nbsp;&nbsp;Recreation and Sports',
    'Recreation and Sports -- Rodeo' => '&nbsp;&nbsp;&nbsp;&nbsp;Rodeo',
    'Recreation and Sports -- Rugby' => '&nbsp;&nbsp;&nbsp;&nbsp;Rugby',
    'Recreation and Sports -- Running' => '&nbsp;&nbsp;&nbsp;&nbsp;Running',
    'Recreation and Sports -- Scuba Diving' => '&nbsp;&nbsp;&nbsp;&nbsp;Scuba Diving',
    'Recreation and Sports -- Skateboarding' => '&nbsp;&nbsp;&nbsp;&nbsp;Skateboarding',
    'Recreation and Sports -- Skiing' => '&nbsp;&nbsp;&nbsp;&nbsp;Skiing',
    'Recreation and Sports -- Snowboarding' => '&nbsp;&nbsp;&nbsp;&nbsp;Snowboarding',
    'Recreation and Sports -- Soccer' => '&nbsp;&nbsp;&nbsp;&nbsp;Soccer',
    'Recreation and Sports -- Sports Apparel' => '&nbsp;&nbsp;&nbsp;&nbsp;Sports Apparel',
    'Recreation and Sports -- Surfing' => '&nbsp;&nbsp;&nbsp;&nbsp;Surfing',
    'Recreation and Sports -- Swimming' => '&nbsp;&nbsp;&nbsp;&nbsp;Swimming',
    'Recreation and Sports -- Tennis' => '&nbsp;&nbsp;&nbsp;&nbsp;Tennis',
    'Recreation and Sports -- Track and Field' => '&nbsp;&nbsp;&nbsp;&nbsp;Track and Field',
    'Recreation and Sports -- Triathlon' => '&nbsp;&nbsp;&nbsp;&nbsp;Triathlon',
    'Recreation and Sports -- Volleyball' => '&nbsp;&nbsp;&nbsp;&nbsp;Volleyball',
    'Recreation and Sports -- Wrestling' => '&nbsp;&nbsp;&nbsp;&nbsp;Wrestling',
    'Reference and Education' => 'Reference and Education',
    'Reference and Education -- College University' => '&nbsp;&nbsp;&nbsp;&nbsp;College University',
    'Reference and Education -- Financial Aid' => '&nbsp;&nbsp;&nbsp;&nbsp;Financial Aid',
    'Reference and Education -- Future Concepts' => '&nbsp;&nbsp;&nbsp;&nbsp;Future Concepts',
    'Reference and Education -- Home Schooling' => '&nbsp;&nbsp;&nbsp;&nbsp;Home Schooling',
    'Reference and Education -- Online Education' => '&nbsp;&nbsp;&nbsp;&nbsp;Online Education',
    'Reference and Education -- Paranormal' => '&nbsp;&nbsp;&nbsp;&nbsp;Paranormal',
    'Reference and Education -- Psychic' => '&nbsp;&nbsp;&nbsp;&nbsp;Psychic',
    'Reference and Education -- Psychology' => '&nbsp;&nbsp;&nbsp;&nbsp;Psychology',
    'Reference and Education -- Reference & Education' => '&nbsp;&nbsp;&nbsp;&nbsp;Reference &amp; Education',
    'Reference and Education -- Science' => '&nbsp;&nbsp;&nbsp;&nbsp;Science',
    'Reference and Education -- Vocational Trade Schools' => '&nbsp;&nbsp;&nbsp;&nbsp;Vocational Trade Schools',
    'Relationships' => 'Relationships',
    'Relationships -- Affairs' => '&nbsp;&nbsp;&nbsp;&nbsp;Affairs',
    'Relationships -- Commitment' => '&nbsp;&nbsp;&nbsp;&nbsp;Commitment',
    'Relationships -- Communication' => '&nbsp;&nbsp;&nbsp;&nbsp;Communication',
    'Relationships -- Conflict' => '&nbsp;&nbsp;&nbsp;&nbsp;Conflict',
    'Relationships -- Dating' => '&nbsp;&nbsp;&nbsp;&nbsp;Dating',
    'Relationships -- Dating for Boomers' => '&nbsp;&nbsp;&nbsp;&nbsp;Dating for Boomers',
    'Relationships -- Divorce' => '&nbsp;&nbsp;&nbsp;&nbsp;Divorce',
    'Relationships -- Enhancement' => '&nbsp;&nbsp;&nbsp;&nbsp;Enhancement',
    'Relationships -- Friendship' => '&nbsp;&nbsp;&nbsp;&nbsp;Friendship',
    'Relationships -- Gay Lesbian' => '&nbsp;&nbsp;&nbsp;&nbsp;Gay Lesbian',
    'Relationships -- Love' => '&nbsp;&nbsp;&nbsp;&nbsp;Love',
    'Relationships -- Marriage Wedding' => '&nbsp;&nbsp;&nbsp;&nbsp;Marriage Wedding',
    'Relationships -- Post Divorce' => '&nbsp;&nbsp;&nbsp;&nbsp;Post Divorce',
    'Relationships -- Readiness' => '&nbsp;&nbsp;&nbsp;&nbsp;Readiness',
    'Relationships -- Relationships' => '&nbsp;&nbsp;&nbsp;&nbsp;Relationships',
    'Relationships -- Sexuality' => '&nbsp;&nbsp;&nbsp;&nbsp;Sexuality',
    'Relationships -- Singles' => '&nbsp;&nbsp;&nbsp;&nbsp;Singles',
    'Science' => 'Science',
    'Science -- Astronomy' => '&nbsp;&nbsp;&nbsp;&nbsp;Astronomy',
    'Science -- Biology' => '&nbsp;&nbsp;&nbsp;&nbsp;Biology',
    'Science -- Environment' => '&nbsp;&nbsp;&nbsp;&nbsp;Environment',
    'Science -- Physics' => '&nbsp;&nbsp;&nbsp;&nbsp;Physics',
    'Science -- Science' => '&nbsp;&nbsp;&nbsp;&nbsp;Science',
    'Science -- Technology' => '&nbsp;&nbsp;&nbsp;&nbsp;Technology',
    'Self Improvement' => 'Self Improvement',
    'Self Improvement -- Addictions' => '&nbsp;&nbsp;&nbsp;&nbsp;Addictions',
    'Self Improvement -- Anger Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Anger Management',
    'Self Improvement -- Attraction' => '&nbsp;&nbsp;&nbsp;&nbsp;Attraction',
    'Self Improvement -- Coaching' => '&nbsp;&nbsp;&nbsp;&nbsp;Coaching',
    'Self Improvement -- Creativity' => '&nbsp;&nbsp;&nbsp;&nbsp;Creativity',
    'Self Improvement -- Goal Setting' => '&nbsp;&nbsp;&nbsp;&nbsp;Goal Setting',
    'Self Improvement -- Grief Loss' => '&nbsp;&nbsp;&nbsp;&nbsp;Grief Loss',
    'Self Improvement -- Happiness' => '&nbsp;&nbsp;&nbsp;&nbsp;Happiness',
    'Self Improvement -- Innovation' => '&nbsp;&nbsp;&nbsp;&nbsp;Innovation',
    'Self Improvement -- Inspirational' => '&nbsp;&nbsp;&nbsp;&nbsp;Inspirational',
    'Self Improvement -- Leadership' => '&nbsp;&nbsp;&nbsp;&nbsp;Leadership',
    'Self Improvement -- Motivation' => '&nbsp;&nbsp;&nbsp;&nbsp;Motivation',
    'Self Improvement -- NLP Hypnosis' => '&nbsp;&nbsp;&nbsp;&nbsp;NLP Hypnosis',
    'Self Improvement -- Organizing' => '&nbsp;&nbsp;&nbsp;&nbsp;Organizing',
    'Self Improvement -- Positive Attitude' => '&nbsp;&nbsp;&nbsp;&nbsp;Positive Attitude',
    'Self Improvement -- Self Esteem' => '&nbsp;&nbsp;&nbsp;&nbsp;Self Esteem',
    'Self Improvement -- Self Improvement' => '&nbsp;&nbsp;&nbsp;&nbsp;Self Improvement',
    'Self Improvement -- Spirituality' => '&nbsp;&nbsp;&nbsp;&nbsp;Spirituality',
    'Self Improvement -- Stress Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Stress Management',
    'Self Improvement -- Success' => '&nbsp;&nbsp;&nbsp;&nbsp;Success',
    'Self Improvement -- Time Management' => '&nbsp;&nbsp;&nbsp;&nbsp;Time Management',
    'Shopping and Product Reviews' => 'Shopping and Product Reviews',
    'Shopping and Product Reviews -- Book Reviews' => '&nbsp;&nbsp;&nbsp;&nbsp;Book Reviews',
    'Shopping and Product Reviews -- Fashion Style' => '&nbsp;&nbsp;&nbsp;&nbsp;Fashion Style',
    'Shopping and Product Reviews -- Jewelry Diamonds' => '&nbsp;&nbsp;&nbsp;&nbsp;Jewelry Diamonds',
    'Shopping and Product Reviews -- Shopping & Products' => '&nbsp;&nbsp;&nbsp;&nbsp;Shopping &amp; Products',
    'Travel and Leisure' => 'Travel and Leisure',
    'Travel and Leisure -- Aviation' => '&nbsp;&nbsp;&nbsp;&nbsp;Aviation',
    'Travel and Leisure -- Cruising Sailing' => '&nbsp;&nbsp;&nbsp;&nbsp;Cruising Sailing',
    'Travel and Leisure -- Destinations' => '&nbsp;&nbsp;&nbsp;&nbsp;Destinations',
    'Travel and Leisure -- Outdoors' => '&nbsp;&nbsp;&nbsp;&nbsp;Outdoors',
    'Travel and Leisure -- Timeshare' => '&nbsp;&nbsp;&nbsp;&nbsp;Timeshare',
    'Travel and Leisure -- Travel and Leisure' => '&nbsp;&nbsp;&nbsp;&nbsp;Travel and Leisure',
    'Travel and Leisure -- Vacation Rentals' => '&nbsp;&nbsp;&nbsp;&nbsp;Vacation Rentals',
    'Travel and Leisure -- Vacations' => '&nbsp;&nbsp;&nbsp;&nbsp;Vacations',
    'Writing and Speaking' => 'Writing and Speaking',
    'Writing and Speaking -- Article Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Article Marketing',
    'Writing and Speaking -- Book Marketing' => '&nbsp;&nbsp;&nbsp;&nbsp;Book Marketing',
    'Writing and Speaking -- Copywriting' => '&nbsp;&nbsp;&nbsp;&nbsp;Copywriting',
    'Writing and Speaking -- Public Speaking' => '&nbsp;&nbsp;&nbsp;&nbsp;Public Speaking',
    'Writing and Speaking -- Teleseminars' => '&nbsp;&nbsp;&nbsp;&nbsp;Teleseminars',
    'Writing and Speaking -- Writing' => '&nbsp;&nbsp;&nbsp;&nbsp;Writing',
    'Writing and Speaking -- Writing and Speaking' => '&nbsp;&nbsp;&nbsp;&nbsp;Writing and Speaking',
    'Writing and Speaking -- Writing Articles' => '&nbsp;&nbsp;&nbsp;&nbsp;Writing Articles'
  );
}

// This class (c) Paul Norman:
// http://www.paul-norman.co.uk/2010/09/php-spinner-updated-spin-articles-for-seo/
//
// Felix Hinkletwink (June 1, 2011 at 2:37 pm) says:
//  Hi there, this is an incredibly useful snippet. Are you okay with it being included in something commercial?
// Paul Norman (June 1, 2011 at 3:36 pm) says:
//  Yep, do what you will with it!

class DAB_Spinner
{
    # Detects whether to use the nested or flat version of the spinner (costs some speed)
    public static function spin($text, $seedPageName = false, $openingConstruct = '{', $closingConstruct = '}', $separator = '|')
    {
        if(preg_match('~'.$openingConstruct.'(?:(?!'.$closingConstruct.').)*'.$openingConstruct.'~s', $text))
        {
            return self::nested($text, $seedPageName, $openingConstruct, $closingConstruct, $separator);
        }
        else
        {
            return self::flat($text, $seedPageName, false, $openingConstruct, $closingConstruct, $separator);
        }
    }

    # The flat version does not allow nested spin blocks, but is much faster (~2x)
    public static function flat($text, $seedPageName, $calculate, $openingConstruct, $closingConstruct, $separator, $calculate = false)
    {
        # Choose whether to return the string or the number of permutations
        $return = 'text';
        if($calculate)
        {
            $permutations   = 1;
            $return         = 'permutations';
        }

        # If we have nothing to spin just exit (don't use a regexp)
        if(strpos($text, $openingConstruct) === false)
        {
            return $$return;
        }

        if(preg_match_all('!'.$openingConstruct.'(.*?)'.$closingConstruct.'!s', $text, $matches))
        {
            # Optional, always show a particular combination on the page
            self::checkSeed($seedPageName);

            $find       = array();
            $replace    = array();

            foreach($matches[0] as $key => $match)
            {
                $choices = explode($separator, $matches[1][$key]);

                if($calculate)
                {
                    $permutations *= count($choices);
                }
                else
                {
                    $find[]     = $match;
                    $replace[]  = $choices[mt_rand(0, count($choices) - 1)];
                }
            }

            if(!$calculate)
            {
                # Ensure multiple instances of the same spinning combinations will spin differently
                $text = self::str_replace_first($find, $replace, $text);
            }
        }

        return $$return;
    }

    # The nested version allows nested spin blocks, but is slower
    public static function nested($text, $seedPageName, $openingConstruct, $closingConstruct, $separator)
    {
        # If we have nothing to spin just exit (don't use a regexp)
        if(strpos($text, $openingConstruct) === false)
        {
            return $text;
        }

        # Find the first whole match
        if(preg_match('!'.$openingConstruct.'(.+?)'.$closingConstruct.'!s', $text, $matches))
        {
            # Optional, always show a particular combination on the page
            self::checkSeed($seedPageName);

            # Only take the last block
            if(($pos = mb_strrpos($matches[1], $openingConstruct)) !== false)
            {
                $matches[1] = mb_substr($matches[1], $pos + mb_strlen($openingConstruct));
            }

            # And spin it
            $parts  = explode($separator, $matches[1]);
            $text   = self::str_replace_first($openingConstruct.$matches[1].$closingConstruct, $parts[mt_rand(0, count($parts) - 1)], $text);

            # We need to continue until there is nothing left to spin
            return self::nested($text, $seedPageName, $openingConstruct, $closingConstruct, $separator);
        }
        else
        {
            # If we have nothing to spin just exit
            return $text;
        }
    }

    # Similar to str_replace, but only replaces the first instance of the needle
    private static function str_replace_first($find, $replace, $string)
    {
        # Ensure we are dealing with arrays
        if(!is_array($find))
        {
            $find = array($find);
        }

        if(!is_array($replace))
        {
            $replace = array($replace);
        }

        foreach($find as $key => $value)
        {
            if(($pos = mb_strpos($string, $value)) !== false)
            {
                # If we have no replacement make it empty
                if(!isset($replace[$key]))
                {
                    $replace[$key] = '';
                }

                $string = mb_substr($string, 0, $pos).$replace[$key].mb_substr($string, $pos + mb_strlen($value));
            }
        }

        return $string;
    }

    private static function checkSeed($seedPageName)
    {
        # Don't do the check if we are using random seeds
        if($seedPageName)
        {
            if($seedPageName === true)
            {
                mt_srand(crc32($_SERVER['REQUEST_URI']));
            }
            elseif($seedPageName == 'every second')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-m-d-H-i-s')));
            }
            elseif($seedPageName == 'every minute')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-m-d-H-i')));
            }
            elseif($seedPageName == 'hourly' OR $seedPageName == 'every hour')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-m-d-H')));
            }
            elseif($seedPageName == 'daily' OR $seedPageName == 'every day')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-m-d')));
            }
            elseif($seedPageName == 'weekly' OR $seedPageName == 'every week')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-W')));
            }
            elseif($seedPageName == 'monthly' OR $seedPageName == 'every month')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y-m')));
            }
            elseif($seedPageName == 'annually' OR $seedPageName == 'every year')
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].date('Y')));
            }
            elseif(preg_match('!every ([0-9.]+) seconds!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / $matches[1])));
            }
            elseif(preg_match('!every ([0-9.]+) minutes!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 60))));
            }
            elseif(preg_match('!every ([0-9.]+) hours!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 3600))));
            }
            elseif(preg_match('!every ([0-9.]+) days!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 86400))));
            }
            elseif(preg_match('!every ([0-9.]+) weeks!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 604800))));
            }
            elseif(preg_match('!every ([0-9.]+) months!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 2620800))));
            }
            elseif(preg_match('!every ([0-9.]+) years!', $seedPageName, $matches))
            {
                mt_srand(crc32($_SERVER['REQUEST_URI'].floor(time() / ($matches[1] * 31449600))));
            }
            else
            {
                throw new Exception($seedPageName. ' Was not a valid spin time option!');
            }
        }
    }
}
